Package: multiClust
Type: Package
Title: multiClust: An R-package for Identifying Biologically Relevant
        Clusters in Cancer Transcriptome Profiles
Version: 1.40.0
Date: 2021-07-27
Authors@R: c(
    person("Nathan","Lawlor", email = "nathan.lawlor03@gmail.com",
    role = c("aut", "cre")),
    person("Peiyong", "Guan", role = "aut"),
    person("Alec","Fabbri", email = "fabbrialhs@gmail.com", role = "aut"),
    person("Krish", "Karuturi", email = "Krishna.Karuturi@jax.org",
    role = "aut"),
    person("Joshy", "George", email = "Joshy.George@jax.org", role = "aut")
    )
Description: Clustering is carried out to identify patterns in
    transcriptomics profiles to determine clinically relevant subgroups
    of patients. Feature (gene) selection is a critical and an integral part
    of the process. Currently, there are many feature selection and clustering
    methods to identify the relevant genes and perform clustering of samples.
    However, choosing an appropriate methodology is difficult. In addition,
    extensive feature selection methods have not been supported by the
    available packages. Hence, we developed an integrative R-package called
    multiClust that allows researchers to experiment with the choice of
    combination of methods for gene selection and clustering with ease.
    Using multiClust, we identified the best performing clustering methodology
    in the context of clinical outcome. Our observations demonstrate that
    simple methods such as variance-based ranking perform well on the majority
    of data sets, provided that the appropriate number of genes is selected.
    However, different gene ranking and selection methods remain relevant
    as no methodology works for all studies.
License: GPL (>= 2)
biocViews: FeatureExtraction, Clustering, GeneExpression, Survival
Imports: mclust, ctc, survival, cluster, dendextend, amap, graphics,
        grDevices
Suggests: knitr, rmarkdown, gplots, RUnit, BiocGenerics,
        preprocessCore, Biobase, GEOquery
VignetteBuilder: knitr
RoxygenNote: 5.0.0
NeedsCompilation: no
Author: Nathan Lawlor [aut, cre], Peiyong Guan [aut], Alec Fabbri [aut], Krish Karuturi [aut], Joshy George [aut]
Maintainer: Nathan Lawlor <nathan.lawlor03@gmail.com>
git_url: https://git.bioconductor.org/packages/multiClust
git_branch: RELEASE_3_22
git_last_commit: 9efff1c
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Packaged: 2025-10-30 05:20:10 UTC; biocbuild

# multiClust

multiClust: An R-package for Identifying Biologically Relevant Clusters in Cancer Transcriptome Profiles

__Installation:__

To install this package, start R and enter:

`if (!requireNamespace("BiocManager", quietly=TRUE))`
    `install.packages("BiocManager")`

`BiocManager::install("multiClust")`

__Tutorial__:

For instructions on how to use multiClust, please see the tutorial available at: https://bioconductor.org/packages/release/bioc/vignettes/multiClust/inst/doc/multiClust.html

__More Information__:

For more information about multiClust, please see the associated publication at:
https://www.ncbi.nlm.nih.gov/pmc/articles/PMC4907340/

WriteMatrixToFile <- function(tmpMatrix, tmpFileName, blnRowNames,
    blnColNames) {
    output <- file(tmpFileName, "at")
    write.table(tmpMatrix, output, sep="\t", quote=FALSE,
        row.names=blnRowNames, col.names=blnColNames)
    close(output)
}

test_WriteMatrixToFile <- function() {
    checkException(WriteMatrixToFile(tmpMatrix= "string",
        tmpFileName= 1, blnRowNames=TRUE,
        blnColNames=TRUE), msg="Unable to use a number for file name")
}

number_clusters <- function(data.exp, Fixed=3, gap_statistic=NULL){
  # Conditional to cause error if user chooses both Fixed and
  #gap_statistic method
  if (is.null(Fixed) == FALSE) {
    if (is.null(gap_statistic) == FALSE) {
      stop("Please choose one of the two options
           (Fixed or gap_statistic) only")
    }
  }

  if (is.null(Fixed) == FALSE) {
    if (is.numeric(Fixed) == TRUE) {
      cluster_num <- Fixed
      print(paste("The fixed cluster number is: ", cluster_num, sep=""))
      return(cluster_num)
    } else {
      stop("Please input an integer for Fixed")
    }
  }
  if (gap_statistic == TRUE) {
    #Makes Expression Data Numeric
    colname <- colnames(data.exp)
    data.exp <- t(apply(data.exp, 1, as.numeric))
    colnames(data.exp) <- colname

    # Transpose the matrix to do the gap_stat calculation by columns
    # clusGap function calculates by rows
    theGap <- cluster::clusGap(t(data.exp),
       FUNcluster=stats::kmeans, K.max=8)
    # This returns a table with K.max rows and 4 other columns
    # The maximum "gap" value corresponds to the optimal cluster number
    gapDF <- as.data.frame(theGap$Tab)
    # Make a new data frame of cluster number and gap statistic
    clust_total <- c(1:dim(gapDF)[1])
    gap_and_clust <- data.frame(clust_total, gapDF[, "gap"])
    # Determine which is maximum gap statistic
    max_gap <- max(gap_and_clust[,2])
    # Obtain cluster number with maximum gap statistic
    cluster_num2 <- which(gap_and_clust[,2] == max_gap)
    print(paste("The gap statistic cluster number is: ",
       cluster_num2, sep=""))
    return(cluster_num2)
  }
}

# Make a test matrix
test_data <- c(1:8)
test_matrix <- matrix(data=test_data, nrow=2, ncol=4)

test_number_clusters <- function() {
    checkException(number_clusters(data.exp=test_matrix, Fixed="string",
        gap_statistic=NULL), msg="Unable to use a string")
}

#############  VII. Survival Analysis  ###############
#' Function to produce Kaplan-Meier Survival Plots of selected gene
#' expression data.
#' @param samp_cluster Object vector containing the samples and the cluster
#' number they belong to. This object is an output of the
#' cluster_analysis function.
#' @param clinical String indicating the name of the text file containing
#' patient clinical information. The file should be a data frame consisting
#' of two columns. The first column contains the patient survival time
#' information in months. The second column indicates occurrence of
#' a censorship (0) or an event (1).
#' @param survival_type String specifying the type of survival event being
#' analyzed. Examples include "Disease-free survival (DFS)",
#' "Overall Survival (OS)", "Relapse-free survival (RFS)", etc.
#' @param data_name String indicating the name to be used to label the plot.
#' @param cluster_type String indicating the type of clustering method
#' used in the cluster_analysis function. "Kmeans" or "HClust"
#' are the two options.
#' @param distance String describing the distance metric uses for HClust in
#' the cluster_analysis function. Options include one of "euclidean",
#' "maximum", manhattan", "canberra", "binary", or "minkowski".
#' @param linkage_type String describing the linkage metric use in the
#' cluster_analysis function. Options include "ward.D2", "average",
#' "complete", "median", "centroid", "single", and "mcquitty".
#' @param probe_rank String indicating the feature selection method used
#' in the probe_ranking function. Options include "CV_Rank",
#' "CV_Guided", "SD_Rank", and "Poly".
#' @param probe_num_selection String indicating the way in which probes
#' were selected in the number_probes function. Options include
#' "Fixed_Probe_Num", "Percent_Probe_Num", and "Adaptive_Probee_Num".
#' @param cluster_num_selection String indicating how the number of
#' clusters were determined in the number_clusters function. Options
#' include "Fixed_Clust_Num" and "Gap_Statistic".
#' @return Produces a pdf image of a Kaplan-Meier Survival Plot with Cox
#' Survival P Value. Also returns an object containing the
#' cox survival P value.
#' @seealso \code{\link{number_clusters}}, \code{\link{number_probes}},
#' \code{\link{probe_ranking}}, \code{\link{cluster_analysis}},
#' \code{\link[survival]{coxph}}
#' @author Alec Fabbri, Nathan Lawlor
#' @examples
#' # Load in a data file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
#'     package="multiClust")
#' data <- input_file(input=data_file)
#' # Choose 300 genes to select for
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
#'     Percent=NULL, Adaptive=NULL)
#' # Choose the "CV_Rank" Method for gene ranking
#' sel.data <- probe_ranking(input=data_file, probe_number=300,
#'     probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
#' # Choose a fixed cluster number of 3
#' clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)
#' # Call function for Kmeans parameters
#' kmeans_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="Kmeans",
#'     distance=NULL, linkage_type=NULL, gene_distance=NULL,
#'     num_clusters=3, data_name="GSE2034 Breast",
#'     probe_rank="CV_Rank", probe_num_selection="Fixed_Probe_Num",
#'     cluster_num_selection="Fixed_Clust_Num")
#' # Load the clinical outcome file
#' clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
#'     package="multiClust")
#' # Example of Calling surv_analysis function
#' surv <- surv_analysis(samp_cluster=kmeans_analysis, clinical=clin_file,
#'     survival_type="RFS", data_name="GSE2034 Breast", cluster_type="Kmeans",
#'      distance=NULL, linkage_type=NULL, probe_rank="CV_Rank",
#'      probe_num_selection="Fixed_Probe_Num",
#'      cluster_num_selection="Fixed_Cluster_Num")
#' @export
surv_analysis <- function(samp_cluster, clinical, survival_type="RFS",
    data_name, cluster_type="HClust", distance="euclidean",
    linkage_type="ward.D2", probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num") {

    # Conditionals to make sure inputs are strings
    if (is.character(clinical) == FALSE) {
        stop("Please input string for clinical")
    }

    if (is.character(survival_type) == FALSE) {
        stop("Please input string for survival_type")
    }

    if (is.character(data_name) == FALSE) {
        stop("Please input string for data_name")
    }

    if (is.character(cluster_type) == FALSE) {
        stop("Please input string for cluster_type")
    }

    if (is.null(distance) == FALSE) {
        if (is.character(distance) == FALSE) {
            stop("Please input string for distance")
        }
    }

    if (is.null(linkage_type) == FALSE) {
        if (is.character(linkage_type) == FALSE) {
            stop("Please input string for linkage_type")
        }
    }

    if (is.character(probe_rank) == FALSE) {
        stop("Please input string for probe_rank")
    }

    if (is.character(probe_num_selection) == FALSE) {
        stop("Please input string for probe_num_selection")
    }

    if (is.character(cluster_num_selection) == FALSE) {
        stop("Please input string for cluster_num_selection")
    }

    # Read in survival data text file
    sample.anns <- utils::read.delim2(clinical, header=TRUE,
        stringsAsFactors=FALSE)
    time <- sample.anns[, 1]
    event <- sample.anns[, 2]
    time <- as.numeric(time)
    event <- as.numeric(event)
    event_type <- survival_type
    time_type <- 'Months'

    # Determine max number of clusters in samp_cluster
    Number_Clusters <- max(samp_cluster)

    # Produce Kaplan Meier survival plots
    lev <- '1'
    for(i in 2:Number_Clusters) {
      lev <- c(lev, paste('',i, sep=''))
    }

    groupfac <- factor(samp_cluster, levels=lev)
    cox <- survival::coxph(survival::Surv(time, event==1) ~ groupfac)
    csumm <- summary(cox)
    cox.p.value <- c(csumm$logtest[3])
    p <- survival::survfit(survival::Surv(time,
        event==1)~survival::strata(samp_cluster))

    # Produce Kaplan-Meier Survival Plot
    grDevices::pdf(paste(data_name, cluster_type, linkage_type, probe_rank,
        probe_num_selection, cluster_num_selection,
        survival_type, "pdf", sep='.'))
    graphics::plot(p, xlab= time_type, ylab='Survival Probability',
        conf.int=FALSE, xlim=c(0,100), col=1:Number_Clusters,
        main=paste(data_name, cluster_type, probe_rank,
        survival_type, sep =' '))
    graphics::legend('bottomleft',
        legend=levels(survival::strata(samp_cluster)),lty=1,
        col=1:Number_Clusters,text.col=1:Number_Clusters, title='clusters')
    graphics::legend('topright', paste('Pvalue =',
        signif(csumm$logtest[3],digits=2), sep=''))
    grDevices::dev.off()
    print("Your Kaplan Meier Survival Plot has been finished")
    return(cox.p.value)
}

probe_ranking <- function(input, probe_number,
    probe_num_selection="Fixed_Probe_Num", data.exp, method="SD_Rank") {

    WriteMatrixToFile <- function(tmpMatrix, tmpFileName,
        blnRowNames, blnColNames) {
    output <- file(tmpFileName, "at")
    utils::write.table(tmpMatrix, output, sep="\t", quote=FALSE,
        row.names=blnRowNames, col.names=blnColNames)
    close(output)
    }

  #Makes Expression Data Numeric
  colname <- colnames(data.exp)
  data.exp <- t(apply(data.exp, 1, as.numeric))
  colnames(data.exp) <- colname

  # If CV_Rank option is chosen
  if (method == "CV_Rank") {
    #Mean and SD Filter
    row.sd <- apply(data.exp, 1, stats::sd)
    row.mean <- apply(data.exp, 1, mean)
    row.cv <- row.sd / row.mean

    # Obtain new gene expression matrix of CV-ranked genes
    data.exp <- data.frame(data.exp, row.cv)
    data.exp <- data.exp[order(data.exp[, dim(data.exp)[2]],
        decreasing=TRUE),]
    data.exp <- data.exp[, -dim(data.exp)[2]]
    newexp.cv <- data.exp[1:probe_number,]
    WriteMatrixToFile(newexp.cv, paste(input, probe_num_selection,
        "CV_Rank_Selected_Gene_Exp.txt", sep="."), TRUE, TRUE)
    print(paste("The selected CV_Rank Gene Expression text file",
        "has been written"))
    return(newexp.cv)
  }

  # If CV_Guided method is chosen
  if (method == "CV_Guided") {
    # Shift the data by the minimum value
    num <- min(data.exp)
    transinput <- data.exp - num

    # Obtain selected gene matrix
    constant <- stats::sd(transinput) / mean(transinput)
    row.sd <- apply(transinput, 1, stats::sd)
    row.mean <- apply(transinput, 1, mean)
    x <- 0
    y <- 55000
    while (y > probe_number) {
      y <- length(which(row.mean > (0.0001 *x) &
          row.sd > (0.0001* constant *x)))
      x <- x + 1
    }
    x <- x - 1

    selmatrix <- transinput[row.mean > (0.0001 *x) &
          row.sd > (.0001 * constant * x),]
    WriteMatrixToFile(selmatrix, paste(input, probe_num_selection,
          "CV_Guided_Selected_Gene_Exp.txt", sep='.'), TRUE, TRUE)
    print(paste("The selected CV_Guided Gene Expression",
          "text file has been written"))
    return(selmatrix)
  }

  if (method == "SD_Rank") {
    # Shift the data by the minimum value
    num <- min(data.exp)
    transinput <- data.exp - num

    # Get selected gene expression matrix
    row.sd <- apply(transinput, 1, stats::sd)
    transinput <- data.frame(transinput, row.sd)
    transinput <- transinput[order(transinput[, dim(transinput)[2]],
        decreasing = TRUE),]
    transinput <- transinput[, -dim(transinput)[2]]
    newexp.sd <- transinput[1:probe_number,]

    WriteMatrixToFile(newexp.sd, paste(input, probe_num_selection,
        "SD_Rank_Selected_Gene_Exp.txt", sep="."), TRUE, TRUE)
    print(paste("The selected SD_Rank Gene Expression",
        "text file has been written"))
    return(newexp.sd)
  }

  if (method == "Poly") {
    # Get mean and standard deviation of each gene
    row.mean <- apply(data.exp, 1, mean)
    row.sd <- apply(data.exp, 1, stats::sd)
    transinput <- data.exp
    # Fit a second degree polynomial to data
    fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
    res <- fit$residuals
    # Determine which genes are above the fitted polynomial
    numgenesel <- length(which(res > 0))
    selgenes <- names(which(res > 0))

    # Obtain the selected gene matrix for genes above the polynomial
    vec <- NULL
    for (i in 1:length(selgenes)) {
      num <- which(rownames(transinput) == selgenes[i])
      vec <- c(vec, num)
    }
    selmatrix <- transinput[vec,]

    # Get mean and sd of new selected gene matrix
    row.mean <- apply(selmatrix, 1, mean)
    row.sd <- apply(selmatrix, 1, stats::sd)

    # Repeat steps and fit second polynomial to data
    fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
    res <- fit$residuals
    numgenesel <- length(which(res > 0))
    selgenes <- names(which(res > 0))

    # Obtain selected gene matrix of genes above the second polynomial fit
    vec <- NULL
    for (i in 1:length(selgenes)) {
      num <- which(rownames(selmatrix) == selgenes[i])
      vec <- c(vec, num)
    }
    selmatrix2 <- selmatrix[vec,]

    # Obtain mean and sd for new genes above the second polynomial fit
    row.mean <- apply(selmatrix2, 1, mean)
    row.sd <- apply(selmatrix2, 1, stats::sd)

    # Fit a third polynomial to the data
    fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
    res <- fit$residuals

    # Order the genes by highest res number
    df <- data.frame(names(res), res)
    newdf <- df[order(df[,dim(df)[2]], decreasing=TRUE),]

    # Conditional if the user input gene number is larger than the
    # Poly selected amount produce an error prompt
    if (dim(newdf)[1] < probe_number) {
      print(paste("The number of genes determined by the Poly",
          "filter was: ", dim(newdf)[1], sep=""))
      stop("Please choose a gene number equal to or less
          than the determined gene number")
    }

    poly_genes <- newdf[1:probe_number,]
    # Obtain the selected gene matrix for genes above the third polynomial
    selgenes <- rownames(poly_genes)

    vec <- NULL
    for (i in 1:length(selgenes)) {
      num <- which(rownames(selmatrix2) == selgenes[i])
      vec <- c(vec, num)
    }
    selmatrix3 <- selmatrix2[vec,]
    WriteMatrixToFile(selmatrix3, paste(input,
        "Poly_Selected_Gene_Exp.txt", sep="."), TRUE, TRUE)
    print(paste("The selected Poly Gene Expression text",
        "file has been written"))
    return(selmatrix3)
    }

  # Conditional to produce error if user does not choose one
  # of available options
  choices <- c("CV_Rank", "CV_Guided", "SD_Rank", "Poly")
  if (is.na(match(method, choices)) == TRUE) {
    stop("Please choose one of the available methods: CV_Rank,
         CV_Guided, SD_Rank, or Poly")
  }
}

# Make a test matrix
test_data <- c(1:8)
test_matrix <- matrix(data=test_data, nrow=2, ncol=4)

test_probe_ranking <- function() {
    checkException(probe_ranking(input="string", probe_number="word",
        probe_num_selection="Fixed_Probe_Num", data.exp=test_matrix,
        method="SD_Rank"), msg="Unable to use string as probe_number")
}

input_file <- function(input) {
    data.exp <- utils::read.delim2(input, header=TRUE,
        stringsAsFactors=FALSE, row.names=NULL)
    rownames(data.exp) <- data.exp[, 1]
    data.exp[, 1] <- NULL
    print("The gene expression matrix has been loaded")
    return(data.exp)
}

test_input_file <- function() {
  checkException(input_file(input=1), msg="Unable to use integer as argument")
}

number_probes <- function(input, data.exp, Fixed=1000, Percent=NULL,
    Poly=NULL, Adaptive=NULL) {
  # Conditional to cause error if user chose multiple methods at once
  if (is.null(Fixed) == FALSE) {
    if (is.null(Percent) == FALSE) {
      stop("Please choose one of the four options
           (Fixed, Percent, Poly, Adaptive) only")
    }
    }

  if (is.null(Fixed) == FALSE) {
    if (is.null(Adaptive) == FALSE) {
      stop("Please choose one of the four options
           (Fixed, Percent, Poly, Adaptive) only")
    }
    }

  if (is.null(Percent) == FALSE) {
    if (is.null(Adaptive) == FALSE) {
      stop("Please choose one of the four options
           (Fixed, Percent, Poly, Adaptive) only")
    }
    }

  if (is.null(Fixed) == FALSE) {
    if (is.null(Poly) == FALSE) {
      stop("Please choose one of the four options
           (Fixed, Percent, Poly, Adaptive) only")
    }
    }

  if (is.null(Percent) == FALSE) {
    if (is.null(Poly) == FALSE) {
      stop("Please choose one of the four options
           (Fixed, Percent, Poly, Adaptive) only")
    }
    }

  if (is.null(Adaptive) == FALSE) {
    if (is.null(Poly) == FALSE) {
      stop("Please choose one of the four options
           (Fixed, Percent, Poly, Adaptive) only")
    }
  }

  # For Fixed method
  if (is.null(Fixed) == FALSE) {
    # Conditional to make sure Fixed is numeric
    if (is.numeric(Fixed) == FALSE) {
      stop("Please input numeric for Fixed")
    }
    gene_num=Fixed
    # Conditional to produce error if fixed gene number is
    # greater than total genes in matrix
    if (gene_num > dim(data.exp)[1]) {
      stop("Gene number chosen is too large")
    }
    print(paste("The fixed gene probe number is: ", gene_num, sep=""))
    return(gene_num)
  }

  # For percent method
  if (is.null(Percent) == FALSE) {
    # Conditional to produce error if Percent chosen is not greater
    # than 0 or less/equal to 1
    if (Percent < 0) {
      stop("Please choose a positive number between 0 and 100")
    }
    if (Percent > 100) {
      stop ("Please choose a positive number between 0 and 100")
    }
    gene_num2 <- round((Percent / 100) * dim(data.exp)[1])
    print(paste("The percent gene probe number is: ", gene_num2, sep=""))
    return(gene_num2)
  }

  # For Poly method
  if (is.null(Poly) == FALSE) {
    # Make data matrix numeric
    colname <- colnames(data.exp)
    data.exp <- t(apply(data.exp, 1, as.numeric))
    colnames(data.exp) <- colname

    # Get mean and standard deviation of each gene
    row.mean <- apply(data.exp, 1, mean)
    row.sd <- apply(data.exp, 1, stats::sd)
    transinput <- data.exp

    # Fit a second degree polynomial to data
    fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
    res <- fit$residuals
    # Determine which genes are above the fitted polynomial
    numgenesel <- length(which(res > 0))
    selgenes <- names(which(res > 0))

    # Obtain the selected gene matrix for genes above the polynomial
    vec <- NULL
    for (i in 1:length(selgenes)){
      num <- which(rownames(transinput) == selgenes[i])
      vec <- c(vec, num)
    }
    selmatrix <- transinput[vec,]

    # Get mean and sd of new selected gene matrix
    row.mean <- apply(selmatrix, 1, mean)
    row.sd <- apply(selmatrix, 1, stats::sd)

    # Repeat steps and fit second polynomial to data
    fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
    res <- fit$residuals
    numgenesel <- length(which(res > 0))
    selgenes <- names(which(res > 0))

    # Obtain selected gene matrix of genes above the second polynomial fit
    vec <- NULL
    for (i in 1:length(selgenes)) {
      num <- which(rownames(selmatrix) == selgenes[i])
      vec <- c(vec, num)
    }
    selmatrix2 <- selmatrix[vec,]

    # Obtain mean and sd for new genes above the second polynomial fit
    row.mean <- apply(selmatrix2, 1, mean)
    row.sd <- apply(selmatrix2, 1, stats::sd)

    # Fit a third polynomial to the data
    fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
    res <- fit$residuals
    numgenesel <- length(which(res > 0))
    selgenes <- names(which(res>0))

    # Obtain selected gene matrix of genes above the third polynomial fit
    vec <- NULL
    for (i in 1:length(selgenes)) {
      num <- which(rownames(selmatrix) == selgenes[i])
      vec <- c(vec, num)
    }

    # Return the number of genes
    gene_poly <- length(vec)
    print(paste("The poly gene probe number is: ", gene_poly, sep=""))
    return(gene_poly)

  }

  # For adaptive method
  if (Adaptive == TRUE) {

    ## Code for Gaussian Mixture Modeling and Selection Process ##
    ## PART 1: NORMALIZATION OF DATA  ##

    # Function to normalize data to bring values into alignment
    nor.min.max <- function(x) {
      x.min <- min(x)
      x.max <- max(x)
      x <- (x - x.min) / (x.max - x.min)
      return (x)
    }

    # Makes Expression Data Numeric
    colname <- colnames(data.exp)
    data.exp <- t(apply(data.exp, 1, as.numeric))
    colnames(data.exp) <- colname

    # Normalization of expression data
    data.min.max <- t(apply(data.exp, 1, nor.min.max))
    rownames(data.min.max) <- rownames(data.exp)
    print("Your data has been normalized")

    ######## PART 2 Generate Simulated Data #########

    # Make normalized data a numeric matrix
    colname <- colnames(data.min.max)
    data.min.max <- t(apply(data.min.max, 1, as.numeric))
    colnames(data.min.max) <- colname

    #Stores number of columns and rows of normalized data into variables
    dsNoOfCol <- NCOL(data.min.max)
    dsNoOfRow <- NROW(data.min.max)

    #specify the names of columns in the data frame
    colnames(data.min.max) <- c(1:dsNoOfCol)
    data.min.max <- data.min.max[, 1:dsNoOfCol]

    #apply function will apply sd and mean to each value in the object
    tmp.mean <- apply(data.min.max, 1, mean)
    tmp.sd <- apply(data.min.max, 1, stats::sd)

    # rnorm generates a random distribution of numbers
    data.sim <- matrix(data=0, nrow=dsNoOfRow, ncol=dsNoOfCol)
    rownames(data.sim) <- rownames(data.min.max)

    for (i in 1:dsNoOfRow) {
      currGeneExpLevel <- stats::rnorm(dsNoOfCol, tmp.mean[i], tmp.sd[i])
      data.sim[i,] <- (currGeneExpLevel)
    }
    print("The simulated data file has been finished")

    ###### PART 3A Apply Gaussian Mixture Modeling to Real Data ######

    # Define file prefix name and other parameters for GMM
    filePrefix <- paste(input, "real_", sep=".")
    expColStart <- 1
    MAX_NO_OF_DIGITS <- 20

    dsNoOfCol <- NCOL(data.min.max)
    dsNoOfRow <- NROW(data.min.max)

    #Set column names as "number 1" through value of dsNoOfCol
    colnames(data.min.max) <- c(expColStart:dsNoOfCol)

    #Stores column numbers into a data frame
    data.min.max <- data.min.max[, expColStart:dsNoOfCol]

    #paste combines the vectors into one string
    #("number of samples: 234" for example)
    print(paste("number of samples: ", dsNoOfCol, sep=""))
    print(paste("number of genes: ", dsNoOfRow, sep=""))

    # calculating the variances
    print(paste("Begin applying Gaussian Mixture Modeling to real data",
                "may take several minutes"))

    for (i in 1:dsNoOfRow) {
      print(i)
      currGeneExpLevel <- data.min.max[i, expColStart:dsNoOfCol]

      # model the gene using Mclust
      gClust <- mclust::Mclust(t(currGeneExpLevel), G=1:6)

      output <- file(paste(filePrefix, "output_pro.txt", sep=""), "at")
      cat(rownames(data.min.max)[i], format(gClust$parameters$pro,
          digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefix, "output_mean.txt", sep=""), "at")
      cat(rownames(data.min.max)[i], format(gClust$parameters$mean,
          digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefix, "output_modelNameG.txt",
          sep=""), "at")
      cat(rownames(data.min.max)[i], gClust$G, gClust$modelName,
          file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefix, "output_sigmasq.txt",
          sep=""), "at")
      cat(rownames(data.min.max)[i],
          format(gClust$parameters$variance$sigmasq,
          digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefix, "output_classification.txt",
          sep=""), "at")
      cat(rownames(data.min.max)[i], gClust$classification,
          file=output, sep="\t")
      cat("\n", file=output)
      close(output)
    }

    print("Gaussian mixture modeling has been applied to your real data")

    ########## PART 3B: Apply GMM to Simu Data  ############

    # Define prefix name for simu data and other parameters for GMM
    expColStart <- 1
    filePrefixsim <- paste(input, "Simu_", sep=".")
    MAX_NO_OF_DIGITS <- 20

    dsNoOfCol <- NCOL(data.sim)
    dsNoOfRow <- NROW(data.sim)

    #Set column names as "number 1" through value of dsNoOfCol
    colnames(data.sim) <- c(expColStart:dsNoOfCol)

    #Stores column numbers into a data frame
    data.sim <- data.sim[, expColStart:dsNoOfCol]

    print(paste("number of samples: ", dsNoOfCol, sep=""))
    print(paste("number of genes: ", dsNoOfRow, sep=""))

    print(paste("Begin applying Gaussian Mixture Modeling to Simulated",
                "Data, may take several minutes"))

    for (i in 1:dsNoOfRow) {
      print(i)
      currGeneExpLevel<- data.sim[i,expColStart:dsNoOfCol]

      # model the gene using Mclust
      gClust <- mclust::Mclust(t(currGeneExpLevel), G=1:6)

      output <- file(paste(filePrefixsim, "output_pro.txt",
                           sep=""), "at")
      cat(rownames(data.sim)[i], format(gClust$parameters$pro,
          digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefixsim, "output_mean.txt",
          sep=""), "at")
      cat(rownames(data.sim)[i], format(gClust$parameters$mean,
          digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefixsim, "output_modelNameG.txt",
          sep=""), "at")
      cat(rownames(data.sim)[i], gClust$G, gClust$modelName,
          file=output, sep="\t")
      cat("\n", file=output)
      close(output)

      output <- file(paste(filePrefixsim, "output_sigmasq.txt",
          sep=""), "at")
      cat(rownames(data.sim)[i],
          format(gClust$parameters$variance$sigmasq,
          digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
      cat("\n", file = output)
      close(output)

      output <- file(paste(filePrefixsim, "output_classification.txt",
          sep=""), "at")
      cat(rownames(data.sim)[i], gClust$classification,
          file=output, sep="\t")
      cat("\n", file = output)
      close(output)
    }

    print(paste("Gaussian Mixture Modeling has been applied to",
                "your simulated data"))

    ####### PART 4: Determine GMM/TRank estimated number of Genes #######

    # Function that sorts a matrix
    mat.sort <- function(mat,n) {
      mat[rank(as.numeric(mat[,n]),
               ties.method="random"),] <- mat[c(1:nrow(mat)),]
      return(mat)
    }

    # Function to compute the TRank value
    compute.TRank <- function(fn.dataModelNameG,
        fn.dataClassification, fn.dataSigmasq, fn.dataMean,
        fn.dataPro,curr.Sigmasq) {
      # Model Name and G
      dataModelNameG <- utils::read.delim2(fn.dataModelNameG,
          header=FALSE, row.names=1, sep="\t", quote="\"",
          dec=".", fill=TRUE)

      # discrete classification produced by mclust
      dataClassification <- utils::read.delim2(fn.dataClassification,
          header=FALSE, row.names=1, sep="\t", quote="\"",
          dec=".", fill=TRUE)

      # Extract Properties of the input file
      # Number of genes
      noOfGene <- NROW(dataModelNameG)
      # Maximum number of gaussians
      maxG <-max(dataModelNameG[, 1])
      # Number of samples
      noOfSample <- NCOL(dataClassification)

      # sigma square produced by mclust
      dataSigmasq <- utils::read.delim2(fn.dataSigmasq,
          header=FALSE, row.names=1, col.names=c(1:(maxG + 1)),
          sep="\t", quote="\"", dec=".", fill=TRUE)

      # mean produced by mclust
      dataMean <- utils::read.delim2(fn.dataMean,
          header=FALSE, row.names=1, col.names=c(1:(maxG + 1)),
          sep="\t", quote="\"", dec=".", fill=TRUE)

      # pi-zero produced by mclust
      dataPro <- utils::read.delim2(fn.dataPro,
          header=FALSE, row.names=1, col.names=c(1:(maxG + 1)),
          sep="\t", quote="\"", dec=".", fill=TRUE)

      # discrete classification produced by mclust
      dataClassification <- utils::read.delim2(fn.dataClassification,
          header=FALSE, row.names=1, col.names=c(1:(noOfSample + 1)),
          sep="\t", quote="\"", dec=".", fill=TRUE)

      #-------------------------------------------------------
      # This matrix stores the gene selection criteria
      #-------------------------------------------------------
      allCriteria <- matrix(nrow=noOfGene, ncol=8)
      print("Begin computing TRank value")
      #-------------------------------------------------------
      #	Calculating the gene selection criteria
      #-------------------------------------------------------
      for (i in 1:noOfGene) {
        print(paste("Now processing Gene ", i))

        # Get the model information.
        # Extract the number of clusters and model name for each gene
        tmpMMADBID <- as.character(rownames(dataModelNameG[i,]))
        tmpG <- dataModelNameG[i, 1]
        tmpModelName <- as.character(dataModelNameG[i, 2])

        # Temporary MATRIX variables to store the statistical criteria
        tmpPWT <- matrix(data=0, nrow=tmpG, ncol=tmpG)
        #-----------------------------------------------------------
        # Calculate the MIN & MAX proportion (pi-zero)
        #-----------------------------------------------------------
        if(tmpG > 1) {
          tmpMinPro <- min(as.numeric(dataPro[tmpMMADBID, 1:tmpG]))
          tmpMaxPro <- max(as.numeric(dataPro[tmpMMADBID, 1:tmpG]))

          #Added to capture the min and max mean (15 July 2011)
          tmpMinMean <- min(as.numeric(dataMean[tmpMMADBID, 1:tmpG]))
          tmpMaxMean <- max(as.numeric(dataMean[tmpMMADBID, 1:tmpG]))
        }

        else {
          tmpMinPro <- 0
          tmpMaxPro <- 0

          #Added to capture the min and max mean (15 July 2011)
          tmpMinMean <- min(as.numeric(dataMean[tmpMMADBID, 1]))
          tmpMaxMean <- max(as.numeric(dataMean[tmpMMADBID, 1]))
        }

        #-----------------------------------------------
        # Experiment (9) - sum(pair-wised)
        #-----------------------------------------------

        for(j in 1:(tmpG - 1)) {
          if(tmpModelName == "X") {
            # do nothing here
          }
          else {
            for(k in (j + 1):(tmpG - 1)) {
              # added on 15 July 2011, otherwise wrong.
              if(k > j) {
                if(tmpModelName == "E") {
                  tmpPWT[j, k] <- (abs(dataMean[tmpMMADBID,j]
                      - dataMean[tmpMMADBID,k]) /
                      sqrt(2 * dataSigmasq[tmpMMADBID, 1] +
                      curr.Sigmasq)) * ((dataPro[tmpMMADBID, j] *
                      dataPro[tmpMMADBID, k]) /
                      ((dataPro[tmpMMADBID, j] +
                      dataPro[tmpMMADBID, k]) ^ 2))
                }
                else if(tmpModelName == "V") {
                  tmpPWT[j, k] <- (abs
                      (dataMean[tmpMMADBID, j] -
                      dataMean[tmpMMADBID, k]) /
                      sqrt(dataSigmasq[tmpMMADBID, j] +
                      dataSigmasq[tmpMMADBID, k] +
                      curr.Sigmasq)) * ((dataPro[tmpMMADBID, j] *
                      dataPro[tmpMMADBID, k]) /
                      ((dataPro[tmpMMADBID, j] +
                      dataPro[tmpMMADBID, k]) ^ 2))
                }
              }
            }
          }
        }

        # store all criteria
        allCriteria[i, 1] <- tmpMMADBID
        allCriteria[i, 2] <- tmpG
        allCriteria[i, 3] <- tmpModelName
        allCriteria[i, 4] <- tmpMinPro
        allCriteria[i, 5] <- tmpMaxPro
        #allCriteria[i, 6] = max(as.numeric(tmpPWT))# max
        allCriteria[i, 6] <- sum(as.numeric(tmpPWT))	# sum
        #Added to capture the min and max mean (15 July 2011)
        allCriteria[i, 7] <- tmpMinMean
        allCriteria[i, 8] <- tmpMaxMean
      }

      #-----------------------------------------------------------
      # sort the matrix by one of the allCriteria
      #-----------------------------------------------------------
      sortedAllCriteria <- mat.sort(allCriteria, 6)
      return (sortedAllCriteria)
    }

    #-------------------------------------------
    #	Global constants
    #-------------------------------------------
    MAX_NO_OF_DIGITS <- 20

    # Read in simu data files for TRank calculation
    tmp.fn.dataModelNameG <- paste(filePrefixsim,
        "output_modelNameG.txt", sep="")
    tmp.fn.dataClassification <- paste(filePrefixsim,
        "output_classification.txt", sep="")
    tmp.fn.dataSigmasq <- paste(filePrefixsim,
        "output_sigmasq.txt", sep="")
    tmp.fn.dataMean <- paste(filePrefixsim,
         "output_mean.txt", sep="")
    tmp.fn.dataPro <- paste(filePrefixsim,
         "output_pro.txt", sep="")

    # Calculate the fudge factor for the simu data
    aS0 <- NULL
    currData <- NULL
    for(i in 1:NROW(data.sim)) {
      currData <- as.numeric(data.sim[i,])
      aS0 <- c(aS0,stats::var(currData))
    }

    tmp.Sigmasq <- stats::median(aS0)
    print(paste("The simulated sigamasq is: ", tmp.Sigmasq, sep=""))

    # Call TRank function to calculate simulated data TRank scores
    x <- compute.TRank(tmp.fn.dataModelNameG, tmp.fn.dataClassification,
        tmp.fn.dataSigmasq, tmp.fn.dataMean, tmp.fn.dataPro, tmp.Sigmasq)
    rownames(x) <- as.character(t(x[, 1]))

    # Begin reading in real data files for TRank calculation
    tmp.fn.dataModelNameG <- paste(filePrefix,
        "output_modelNameG.txt", sep="")
    tmp.fn.dataClassification <- paste(filePrefix,
        "output_classification.txt", sep="")
    tmp.fn.dataSigmasq <- paste(filePrefix,
        "output_sigmasq.txt", sep="")
    tmp.fn.dataMean <- paste(filePrefix,
        "output_mean.txt", sep="")
    tmp.fn.dataPro <- paste(filePrefix,"output_pro.txt", sep = "")

    #calculating the fuge factor s0 for real data
    aS0 <- NULL
    currData <- NULL

    for(i in 1:NROW(data.min.max)) {
      currData <- as.numeric(data.min.max[i,])
      aS0 <- c(aS0,stats::var(currData))
    }

    tmp.Sigmasq <- stats::median(aS0)
    print(paste("The real sigamasq is: ", tmp.Sigmasq, sep=""))

    # Call TRank function to calculate TRank scores for real data
    y <- compute.TRank(tmp.fn.dataModelNameG, tmp.fn.dataClassification,
        tmp.fn.dataSigmasq, tmp.fn.dataMean, tmp.fn.dataPro, tmp.Sigmasq)
    rownames(y) <- as.character(t(y[, 1]))

    # Store TRank scores for simu (x.score) and real data (y.score)
    x.score <- as.numeric(t(x[, 6]))
    y.score <- as.numeric(t(y[, 6]))

    #FDR calculations
    maxScore <- max(c(x.score, y.score))
    currCutoff <- min(c(x.score, y.score))
    FDR <- NULL
    bin.size <- 0.001

    while(currCutoff <= maxScore) {
      a <- sum(x.score > currCutoff)
      b <- sum(y.score > currCutoff)
      currFDR <- a / b
      FDR <- rbind(FDR, c(a, b, currCutoff, currFDR))
      currCutoff <- currCutoff + bin.size
    }

    # Choose the TRank with a FDR value of 0.01 for the lowest number
    # of selected genes a represents the index of the TRank
    # value to be chosen

    FDRvalue <- 0.01
    index <- which(FDR[, 4] >= FDRvalue)

    # Conditional if FDR value never reaches specified value
    # Reduce the FDRvalue

    if (length(index) == 0) {
      index <- which(FDR[, 4] >= (FDRvalue / 10))
      if (length(index) == 0) {
        index <- which(FDR[, 4] >= (FDRvalue / 50))
        if (length(index) == 0) {
          index <- which(FDR[, 4] >= (FDRvalue / 100))
          if (length(index) == 0) {
            index <- which(FDR[, 4] >= (FDRvalue / 1000))
          }
        }
      }
    }

    genenum <- max(index)
    TRank <- FDR[genenum, 3]
    # Conditionals to make sure only one TRank value is chosen
    if (length(TRank) == 0) {
      TRank <- 0.30
      print("Arbitrary TRank value of 0.30 chosen")
      print("The specified FDR cutoff did not occur in the data")
    }

    # Conditional if more than 1 TRank value exists with the FDR cutoff
    if (length(TRank) > 1) {
      TRank <- min(TRank)
    }
    # Save the TRank determined genes to object
    sel.Probe <- as.character(y[as.numeric(y[, 6]) >= TRank, 1])
    gene_num3 <- length(sel.Probe)
    print(paste("The adaptive gene probe number is: ", gene_num3, sep=""))
    return(gene_num3)
  }

}

# Make a test matrix
test_data <- c(1:8)
test_matrix <- matrix(data=test_data, nrow=2, ncol=4)

test_number_probes <- function() {
    checkException(number_probes(input="test", data.exp="string", Fixed=1,
        Percent=NULL, Poly=NULL, Adaptive=NULL),
        msg="Unable to use string as data.exp")
    checkException(number_probes(input="test", data.exp=test_matrix, Fixed=NULL,
        Percent=TRUE, Poly=TRUE, Adaptive=NULL),
        msg="Can't have multiple options as true")
}

nor.min.max <- function(x) {
    if (is.numeric(x) == FALSE) {
        stop("Please input numeric for x")
    }
    x.min <- min(x)
    x.max <- max(x)
    x <- (x - x.min) / (x.max - x.min)
    return (x)
}

# Make a test matrix
test_data <- c(1:8)
test_matrix <- matrix(data=test_data, nrow=2, ncol=4)

# Make a normalized matrix
normalized_matrix <- nor.min.max(test_matrix)

test_nor.min.max <- function() {
    checkEqualsNumeric(nor.min.max(test_matrix), normalized_matrix)
    checkException(nor.min.max("a"), msg="Unable to use a string")
}

surv_analysis <- function(samp_cluster, clinical, survival_type="RFS",
    data_name, cluster_type="HClust", distance="euclidean",
    linkage_type="ward.D2", probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num") {

  # Conditionals to make sure inputs are strings
  if (is.character(clinical) == FALSE) {
    stop("Please input string for clinical")
  }

  if (is.character(survival_type) == FALSE) {
    stop("Please input string for survival_type")
  }

  if (is.character(data_name) == FALSE) {
    stop("Please input string for data_name")
  }

  if (is.character(cluster_type) == FALSE) {
    stop("Please input string for cluster_type")
  }

  if (is.null(distance) == FALSE) {
    if (is.character(distance) == FALSE) {
      stop("Please input string for distance")
    }
  }

  if (is.null(linkage_type) == FALSE) {
    if (is.character(linkage_type) == FALSE) {
      stop("Please input string for linkage_type")
    }
  }

  if (is.character(probe_rank) == FALSE) {
    stop("Please input string for probe_rank")
  }

  if (is.character(probe_num_selection) == FALSE) {
    stop("Please input string for probe_num_selection")
  }

  if (is.character(cluster_num_selection) == FALSE) {
    stop("Please input string for cluster_num_selection")
  }

  # Read in survival data text file
  sample.anns <- utils::read.delim2(clinical, header=TRUE,
                                    stringsAsFactors=FALSE)
  time <- sample.anns[, 1]
  event <- sample.anns[, 2]
  time <- as.numeric(time)
  event <- as.numeric(event)
  event_type <- survival_type
  time_type <- 'Months'

  # Determine max number of clusters in samp_cluster
  Number_Clusters <- max(samp_cluster)

  # Produce Kaplan Meier survival plots
  lev <- '1'
  for(i in 2:Number_Clusters) {
    lev <- c(lev, paste('',i, sep=''))
  }

  groupfac <- factor(samp_cluster, levels=lev)
  cox <- survival::coxph(survival::Surv(time, event==1) ~ groupfac)
  csumm <- summary(cox)
  cox.p.value <- c(csumm$logtest[3])
  p <- survival::survfit(survival::Surv(time,
    event==1)~survival::strata(samp_cluster))

  # Produce Kaplan-Meier Survival Plot
  grDevices::pdf(paste(data_name, cluster_type, linkage_type, probe_rank,
    probe_num_selection, cluster_num_selection,
    survival_type, "pdf", sep='.'))
  graphics::plot(p, xlab= time_type, ylab='Survival Probability',
    conf.int=FALSE, xlim=c(0,100), col=1:Number_Clusters,
    main=paste(data_name, cluster_type, probe_rank,
    survival_type, sep =' '))
  graphics::legend('bottomleft',
    legend=levels(survival::strata(samp_cluster)),lty=1,
    col=1:Number_Clusters,text.col=1:Number_Clusters, title='clusters')
  graphics::legend('topright', paste('Pvalue =',
    signif(csumm$logtest[3],digits=2), sep=''))
  grDevices::dev.off()
  print("Your Kaplan Meier Survival Plot has been finished")
  return(cox.p.value)
}

# Make a test samp_cluster vector
samples <- c("a", "b", "c,", "d")

test_surv_analysis <- function() {
    checkException(surv_analysis(samp_cluster=samples, clinical = 1,
    surv_type = "RFS", data_name = "test", cluster_type="HClust",
    distance="euclidean", linkage_type="ward.D2",
    data_name="word", probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num"))
}

#' Function to normalize data to bring values into alignment. This function
#' uses feature scaling to normalize values in a dataset between 0 and 1.
#' @param x An integer object of numeric value
#' @return Returns a numeric value normalized between 0 and 1.
#' @author Peiyong Guan
#' @examples
#'
#' # Load sample dataset
#' data(iris)
#' # View sample matrix
#' iris[1:5, 1:5]
#' # Coerce sample matrix to numeric values
#' iris <- t(apply(iris[, 1:4], 1, as.numeric))
#' #Normalize values in the matrix using the function
#' data.min.max <- t(apply(iris, 1, nor.min.max))
#' @export
nor.min.max <- function(x) {
  if (is.numeric(x) == FALSE) {
    stop("Please input numeric for x")
  }
  x.min <- min(x)
  x.max <- max(x)
  x <- (x - x.min) / (x.max - x.min)
  return (x)
}

## ----eval=TRUE, message=FALSE-------------------------------------------------
# Load GEO and biobase libraries
library(GEOquery)
library(Biobase)
library(multiClust)
library(preprocessCore)
library(ctc)
library(gplots)
library(dendextend)
library(graphics)
library(grDevices)
library(amap)
library(survival)

## ----eval=FALSE, message=FALSE------------------------------------------------
# # Obtain GSE series matrix file from GEO website using getGEO function
# gse <- getGEO(GEO="GSE2034")
# 
# # Save the gene expression matrix as an object
# data.gse <- exprs(gse[[1]])
# 
# # Save the patient clinical data to an object
# pheno <- pData(phenoData(gse[[1]]))
# 
# # Write the gene expression and clinical data to text files
# WriteMatrixToFile(tmpMatrix=data.gse, tmpFileName="GSE2034.expression.txt",
#     blnRowNames=TRUE, blnColNames=TRUE)
# 
# WriteMatrixToFile(tmpMatrix=pheno, tmpFileName="GSE2034.clinical.txt",
#     blnRowNames=TRUE, blnColNames=TRUE)
# 

## ----eval=FALSE---------------------------------------------------------------
# # Obtain GSE series matrix file from GEO website using getGEO function
# gse <- getGEO(filename="GSE2034_series_matrix.txt.gz")
# 
# # Save the gene expression matrix as an object
# data.gse <- exprs(gse[[1]])
# 
# # Save the patient clinical data to an object
# pheno <- pData(phenoData(gse[[1]]))
# 
# # Write the gene expression and clinical data to text files
# WriteMatrixToFile(tmpMatrix=data.gse, tmpFileName="GSE2034.expression.txt",
#     blnRowNames=TRUE, blnColNames=TRUE)
# 
# WriteMatrixToFile(tmpMatrix=pheno, tmpFileName="GSE2034.clinical.txt",
#     blnRowNames=TRUE, blnColNames=TRUE)
# 

## ----eval=FALSE---------------------------------------------------------------
# # Obtain GSE series matrix file from GEO website using getGEo function
# gse <- getGEO(GEO="GSE2034")
# 
# # Save the gene expression matrix as an object
# data.gse <- exprs(gse)
# 
# # Quantile normalization of the dataset
# data.norm <- normalize.quantiles(data.gse, copy=FALSE)
# 
# # shift data before log scaling to prevent errors from log scaling
#     # negative numbers
# if (min(data.norm)> 0) {
#     }
#     else {
#         mindata.norm=abs(min(data.norm)) + .001
#         data.norm=data.norm + mindata.norm
#     }
# 
# # Log2 scaling of the dataset
# data.log <- t(apply(data.norm, 1, log2))
# 
# # Write the gene expression and clinical data to text files
# WriteMatrixToFile(tmpMatrix=data.log,
#     tmpFileName="GSE2034.normalized.expression.txt",
#     blnRowNames=TRUE, blnColNames=TRUE)
# 

## ----eval=TRUE----------------------------------------------------------------
# Obtain clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")

# Load in survival information file
clinical <- read.delim2(file=clin_file, header=TRUE)

# Display first few rows of the file
clinical[1:5, 1:2]

# Column one represents the survival time in months
# Column two represents the relapse free survival (RFS) event 


## ----eval=TRUE----------------------------------------------------------------
# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt", package= "multiClust")

# Load the gene expression matrix 
data.exprs <- input_file(input=exp_file)

# View the first few rows and columns of the matrix
data.exprs[1:4,1:4]

## ----eval=TRUE----------------------------------------------------------------
# Example 1: Choosing a fixed gene or probe number

# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

gene_num <- number_probes(input=exp_file,
    data.exp=data.exprs, Fixed=300,
    Percent=NULL, Poly=NULL, Adaptive=NULL)


## ----eval=TRUE----------------------------------------------------------------
# Example 2: Choosing 50% of the total selected gene probes in a dataset
# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

gene_num <- number_probes(input=exp_file, 
    data.exp=data.exprs, Fixed=NULL,
    Percent=50, Poly=NULL, Adaptive=NULL)


## ----eval=TRUE----------------------------------------------------------------
# Example 3: Choosing the polynomial selected gene probes in a dataset
# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

gene_num <- number_probes(input=exp_file, 
    data.exp=data.exprs, Fixed=NULL,
    Percent=NULL, Poly=TRUE, Adaptive=NULL)


## ----eval=FALSE---------------------------------------------------------------
# # Example 4: Choosing the Adaptive Gaussian Mixture Modeling method
# 
# gene_num <- number_probes(input=exp_file,
#     data.exp=data.exprs, Fixed=NULL,
#     Percent=NULL, Poly=NULL, Adaptive=TRUE)
# 

## ----eval=TRUE----------------------------------------------------------------

# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

# Load the gene expression matrix 
data.exprs <- input_file(input=exp_file)

# Call probe_ranking function
# Select for 500 probes
# Choose genes using the SD_Rank method
ranked.exprs <- probe_ranking(input=exp_file,
    probe_number=300, 
    probe_num_selection="Fixed_Probe_Num",
    data.exp=data.exprs, 
    method="SD_Rank")

# Display the first few columns and rows of the matrix
ranked.exprs[1:4,1:4]


## ----eval=TRUE----------------------------------------------------------------

# Call the number_clusters function
# data.exp is the original expression matrix object outputted from
# the input_file function
# User specifies that samples will be separated into 3 clusters 
# with the "Fixed" argument
cluster_num <- number_clusters(data.exp=data.exprs, Fixed=3,
    gap_statistic=NULL)


## ----eval=FALSE---------------------------------------------------------------
# 
# # Call the number_clusters function
# # data.exp is the original expression matrix object ouputted from
# # the input_file function
# # User chooses the gap_statistic option by making gap_statistic equal TRUE
# # The Fixed argument is also set to NULL
# cluster_num <- number_clusters(data.exp=data.exprs, Fixed=NULL,
#     gap_statistic=TRUE)
# 

## ----eval=TRUE, fig.show='hold', warning=FALSE--------------------------------

# Call the cluster_analysis function
hclust_analysis <- cluster_analysis(sel.exp=ranked.exprs,
    cluster_type="HClust",
    distance="euclidean", linkage_type="ward.D2", 
    gene_distance="correlation",
    num_clusters=3, data_name="GSE2034 Breast", 
    probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")

# Display the first few columns and rows of the object
head(hclust_analysis)


## ----eval=TRUE, echo=FALSE, fig.show='hold', fig.width=8, fig.height=8, fig.align='center', warning=FALSE----
# retrieve file path for image
fpath <- system.file("extdata", "GSE2034_Breast.SD_Rank.ward.D2.Fixed_Probe_Num.Fixed_Clust_Num.jpg", package="multiClust")
knitr::include_graphics(path = fpath)

## ----eval=TRUE, echo=FALSE, fig.show='hold', fig.width=8, fig.height=8, fig.align='center', warning=FALSE----
# Produce a sample dendrogram using the selected gene/probe expression object
# In the function, cluster_analysis the dendrogram is not displayed in
# the console. 

# Make the selected expression object numeric
colname <- colnames(ranked.exprs)
ranked.exprs <- t(apply(ranked.exprs, 1,as.numeric))
colnames(ranked.exprs) <- colname

# Normalization of the selected expression matrix before clustering
norm.sel.exp <- t(apply(ranked.exprs, 1, nor.min.max))

hc <- hclust(dist(x=t(norm.sel.exp), method="euclidean"), method="ward.D2")
dc <- as.dendrogram(hc)

# Portray the samples in each cluster as a different color
dc <- set(dc, "branches_k_color", value=1:3, k=3)

# Make a vector filled with blank spaces to replace sample names with
    # blank space
vec <- NULL
len <- length(labels(dc))
for (i in 1:len) {
  i <- ""
  vec <- c(vec, i)
}

# Remove sample labels from dendrogram
dc <- dendextend::set(dc, "labels", vec)

# Plot the sample dendrogram
plot(dc, main=paste("GSE2034 Breast", "Sample Dendrogram", sep=" "))

# Display orange lines on the plot to clearly separate each cluster
rect.dendrogram(dc, k=3, border='orange')


## ----eval=TRUE----------------------------------------------------------------

# Call the cluster_analysis function
 kmeans_analysis <- cluster_analysis(sel.exp=ranked.exprs,
    cluster_type="Kmeans",
    distance=NULL, linkage_type=NULL, 
    gene_distance=NULL, num_clusters=3,
    data_name="GSE2034 Breast", probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")
 
 # Display the first few rows and columns of the object
 head(kmeans_analysis)


## ----eval=TRUE----------------------------------------------------------------

# Call the avg_probe_exp function
avg_matrix <- avg_probe_exp(sel.exp=ranked.exprs,
    samp_cluster=kmeans_analysis,
    data_name="GSE2034 Breast", cluster_type="Kmeans", distance=NULL,
    linkage_type=NULL, probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")

# Display the first few rows and columns of the matrix
head(avg_matrix)


## ----eval=TRUE, fig.show='hold'-----------------------------------------------
# Obtain clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")

# Call the avg_probe_exp function
surv <- surv_analysis(samp_cluster=kmeans_analysis, clinical=clin_file,
    survival_type="RFS", data_name="GSE2034 Breast", 
    cluster_type="Kmeans", distance=NULL,
    linkage_type=NULL, probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num", 
    cluster_num_selection="Fixed_Clust_Num")

# Display the survival P value
surv


## ----eval=TRUE, echo=FALSE, fig.show='hold', fig.width=8, fig.height=8, fig.align='center', warning=FALSE----

# Obtain clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")

# Produce a Kaplan-Meier plot using the sample cluster information
# from the cluster_analysis function

# Read in survival data text file
sample.anns <- read.delim2(file=clin_file, 
    header=TRUE, stringsAsFactors=FALSE)
time <- sample.anns[,1]
event <- sample.anns[,2]
time <- as.numeric(time)
event <- as.numeric(event)
event_type <- "RFS"
time_type <- 'Months'

# Determine max number of clusters in samp_cluster
samp_cluster <- kmeans_analysis
Number_Clusters <- max(samp_cluster)

# Produce Kaplan Meier survival plots
lev <- '1'
for(i in 2:Number_Clusters) {
    lev <- c(lev, paste('',i, sep=''))
}

groupfac <- factor(samp_cluster, levels=lev)
cox <- coxph(Surv(time, event==1) ~ groupfac)
csumm <- summary(cox)
cox.p.value <- c(csumm$logtest[3])
p <- survfit(Surv(time,event==1)~strata(samp_cluster))

plot (p,xlab= time_type ,ylab='Survival Probability',conf.int=FALSE, 
    xlim=c(0,100), col=1:Number_Clusters, 
    main=paste("GSE2034 Breast", "Kmeans", "SD_Rank", "RFS", sep =' '))

legend('bottomleft',legend=levels(strata(samp_cluster)),lty=1,
    col=1:Number_Clusters, text.col=1:Number_Clusters, title='clusters')

legend('topright', paste('Pvalue =', signif(csumm$logtest[3],digits=2),
    sep =''))

######## I. Input Gene Expression Matrix ####################
#' Function to read-in the gene expression file and assign gene probe names as the rownames.
#' @param input String indicating the name of the text file containing the gene
#' expression matrix to be read in. This matrix file should have the gene probes
#' in the first column of the matrix. The gene probes will be assigned as
#' the rownames of the matrix.
#' @return Returns an object containing the gene expression matrix with the
#' gene probe names as the rownames.
#' @seealso \code{\link[utils]{read.table}}
#' @author Nathan Lawlor
#' @note This function works best when using gene expression datasets from Gene Expression
#' Omnibus.
#' @examples
#' # Load in a test file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt", package = "multiClust")
#' data <- input_file(input = data_file)
#' # View matrix with gene probes assigned as rownames
#' data[1:4,1:4]
#' @export
input_file <- function(input) {
  data.exp <- utils::read.delim2(input, header = TRUE, stringsAsFactors = FALSE, row.names = NULL)
  rownames(data.exp) <- data.exp[,1]
  data.exp[,1] <- NULL
  print("The gene expression matrix has been loaded")
  return(data.exp)
}

##### II. Number of Features (Gene Probes) to Select For #####
#' Function to determine the number of gene probes to select for in the gene
#' feature selection process.
#' @param input String indicating the name of the file containing your
#' gene expression matrix.
#' @param data.exp The object containing your numeric gene expression matrix.
#' This matrix is an output of the input_file function previously introduced
#' in this package.
#' @param Fixed A positive integer specifying a desired number of gene probes
#' to select for. The default is set to 1000 gene probes.
#' @param Percent A positive integer between 0 and 100 indicating the
#' percentage of total gene probes to select for from the dataset.
#' @param Poly When TRUE, a mean and variance polynomial method is used to
#' determine the number of gene probes to select for. This method uses three
#' second order polynomials to select for the genes with the most variable
#' mean and standard deviations.
#' @param Adaptive When TRUE, Gaussian mixture modeling is used
#' to determine the number of gene probes to select.
#' @param cutoff Positive number between 0 and 1 specifying the false
#' discovery rate (FDR) cutoff to use with the Adaptive Gaussian mixture
#' modeling method. The default value is set to NULL. However, when Adaptive
#' is TRUE, cutoff should be a positive integer between 0 and 1. Common
#' values to use are 0.05 or 0.01.
#' @return Returns an object with the  number of gene probes that will be
#' selected in the gene feature selection process. If the Adaptive option
#' is chosen, Gaussian mixture modeling files containing information about
#' the data's mean, variance, mixing proportion, and gaussian assignment
#' are also outputted.
#' @note When using this function, the user should only use one
#' option (Fixed, Percent, Adaptive) at a time. When using one method, all
#' other options should be set to NULL.
#' @note This function is not needed to determine the number of gene probes
#' to select for in the Poly gene selection method.
#' The particular Poly method does not use a gene probe number input.
#' @seealso \code{\link{input_file}}
#' @author Peiyong Guan, Nathan Lawlor
#' @examples
#' # Example 1: Choosing a fixed gene probe number
#' # Load in a test file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
#'     package="multiClust")
#' data <- input_file(input=data_file)
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
#'     Percent=NULL, Poly=NULL, Adaptive=NULL, cutoff=NULL)
#'
#' # Example 2: Choosing 50% of the total selected gene probes in a dataset
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=NULL,
#'     Percent=50, Poly=NULL, Adaptive=NULL, cutoff=NULL)
#'
#' # Example 3: Choosing the Poly method
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=NULL,
#'     Percent=NULL, Poly=TRUE, Adaptive=NULL, cutoff=NULL)
#' \dontrun{
#' # Example 4: Choosing the Adaptive Gaussian Mixture Modeling method
#' # Very long computation time, so example will not be run
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=NULL,
#'     Percent=NULL, Poly=NULL, Adaptive=TRUE, cutoff=0.01)
#'    }
#' @export
number_probes <- function(input, data.exp, Fixed=1000, Percent=NULL,
    Poly=NULL, Adaptive=NULL, cutoff=NULL) {
    # Conditional to cause error if user chose multiple methods at once
    if (is.null(Fixed) == FALSE) {
        if (is.null(Percent) == FALSE) {
            stop("Please choose one of the four options
                (Fixed, Percent, Poly, Adaptive) only")
        }
    }

    if (is.null(Fixed) == FALSE) {
        if (is.null(Adaptive) == FALSE) {
            stop("Please choose one of the four options
                (Fixed, Percent, Poly, Adaptive) only")
        }
    }

    if (is.null(Percent) == FALSE) {
        if (is.null(Adaptive) == FALSE) {
            stop("Please choose one of the four options
                (Fixed, Percent, Poly, Adaptive) only")
            }
    }

    if (is.null(Fixed) == FALSE) {
        if (is.null(Poly) == FALSE) {
            stop("Please choose one of the four options
                (Fixed, Percent, Poly, Adaptive) only")
        }
    }

    if (is.null(Percent) == FALSE) {
        if (is.null(Poly) == FALSE) {
            stop("Please choose one of the four options
                 (Fixed, Percent, Poly, Adaptive) only")
        }
    }

    if (is.null(Adaptive) == FALSE) {
        if (is.null(Poly) == FALSE) {
            stop("Please choose one of the four options
                (Fixed, Percent, Poly, Adaptive) only")
        }
    }

    # For Fixed method
    if (is.null(Fixed) == FALSE) {
        # Conditional to make sure Fixed is numeric
        if (is.numeric(Fixed) == FALSE) {
           stop("Please input numeric for Fixed")
        }
        gene_num=Fixed
        # Conditional to produce error if fixed gene number is
            # greater than total genes in matrix
        if (gene_num > dim(data.exp)[1]) {
            stop("Gene number chosen is too large")
        }
        print(paste("The fixed gene probe number is: ", gene_num, sep=""))
        return(gene_num)
    }

    # For percent method
    if (is.null(Percent) == FALSE) {
        # Conditional to produce error if Percent chosen is not greater
            # than 0 or less/equal to 1
        if (Percent < 0) {
            stop("Please choose a positive number between 0 and 100")
        }
        if (Percent > 100) {
            stop ("Please choose a positive number between 0 and 100")
        }
        gene_num2 <- round((Percent / 100) * dim(data.exp)[1])
        print(paste("The percent gene probe number is: ", gene_num2, sep=""))
        return(gene_num2)
    }

    # For Poly method
    if (is.null(Poly) == FALSE) {
        # Make data matrix numeric
        colname <- colnames(data.exp)
        data.exp <- t(apply(data.exp, 1, as.numeric))
        colnames(data.exp) <- colname

        # Get mean and standard deviation of each gene
        row.mean <- apply(data.exp, 1, mean)
        row.sd <- apply(data.exp, 1, stats::sd)
        transinput <- data.exp

        # Fit a second degree polynomial to data
        fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
        res <- fit$residuals
        # Determine which genes are above the fitted polynomial
        numgenesel <- length(which(res > 0))
        selgenes <- names(which(res > 0))

        # Obtain the selected gene matrix for genes above the polynomial
        vec <- NULL
        for (i in 1:length(selgenes)){
            num <- which(rownames(transinput) == selgenes[i])
            vec <- c(vec, num)
        }
        selmatrix <- transinput[vec,]

        # Get mean and sd of new selected gene matrix
        row.mean <- apply(selmatrix, 1, mean)
        row.sd <- apply(selmatrix, 1, stats::sd)

        # Repeat steps and fit second polynomial to data
        fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
        res <- fit$residuals
        numgenesel <- length(which(res > 0))
        selgenes <- names(which(res > 0))

        # Obtain selected gene matrix of genes above the second polynomial fit
        vec <- NULL
        for (i in 1:length(selgenes)) {
          num <- which(rownames(selmatrix) == selgenes[i])
          vec <- c(vec, num)
        }
        selmatrix2 <- selmatrix[vec,]

        # Obtain mean and sd for new genes above the second polynomial fit
        row.mean <- apply(selmatrix2, 1, mean)
        row.sd <- apply(selmatrix2, 1, stats::sd)

        # Fit a third polynomial to the data
        fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
        res <- fit$residuals
        numgenesel <- length(which(res > 0))
        selgenes <- names(which(res>0))

        # Obtain selected gene matrix of genes above the third polynomial fit
        vec <- NULL
        for (i in 1:length(selgenes)) {
          num <- which(rownames(selmatrix) == selgenes[i])
          vec <- c(vec, num)
        }

        # Return the number of genes
        gene_poly <- length(vec)
        print(paste("The poly gene probe number is: ", gene_poly, sep=""))
        return(gene_poly)

    }

    # For adaptive method
    if (Adaptive == TRUE) {

        if (is.numeric(cutoff) == FALSE) {
          stop("Please input numeric for FDR cutoff")
        }

        ## Code for Gaussian Mixture Modeling and Selection Process ##
        ## PART 1: NORMALIZATION OF DATA  ##

        # Function to normalize data to bring values into alignment
        nor.min.max <- function(x) {
            x.min <- min(x)
            x.max <- max(x)
            x <- (x - x.min) / (x.max - x.min)
            return (x)
        }

        # Makes Expression Data Numeric
        colname <- colnames(data.exp)
        data.exp <- t(apply(data.exp, 1, as.numeric))
        colnames(data.exp) <- colname

        # Normalization of expression data
        data.min.max <- t(apply(data.exp, 1, nor.min.max))
        rownames(data.min.max) <- rownames(data.exp)
        print("Your data has been normalized")

        ######## PART 2 Generate Simulated Data #########

        # Make normalized data a numeric matrix
        colname <- colnames(data.min.max)
        data.min.max <- t(apply(data.min.max, 1, as.numeric))
        colnames(data.min.max) <- colname

        #Stores number of columns and rows of normalized data into variables
        dsNoOfCol <- NCOL(data.min.max)
        dsNoOfRow <- NROW(data.min.max)

        #specify the names of columns in the data frame
        colnames(data.min.max) <- c(1:dsNoOfCol)
        data.min.max <- data.min.max[, 1:dsNoOfCol]

        #apply function will apply sd and mean to each value in the object
        tmp.mean <- apply(data.min.max, 1, mean)
        tmp.sd <- apply(data.min.max, 1, stats::sd)

        # rnorm generates a random distribution of numbers
        data.sim <- matrix(data=0, nrow=dsNoOfRow, ncol=dsNoOfCol)
        rownames(data.sim) <- rownames(data.min.max)

        for (i in 1:dsNoOfRow) {
            currGeneExpLevel <- stats::rnorm(dsNoOfCol, tmp.mean[i], tmp.sd[i])
            data.sim[i,] <- (currGeneExpLevel)
        }
        print("The simulated data file has been finished")

        ###### PART 3A Apply Gaussian Mixture Modeling to Real Data ######

        # Define file prefix name and other parameters for GMM
        filePrefix <- paste(input, "real_", sep=".")
        expColStart <- 1
        MAX_NO_OF_DIGITS <- 20

        dsNoOfCol <- NCOL(data.min.max)
        dsNoOfRow <- NROW(data.min.max)

        #Set column names as "number 1" through value of dsNoOfCol
        colnames(data.min.max) <- c(expColStart:dsNoOfCol)

        #Stores column numbers into a data frame
        data.min.max <- data.min.max[, expColStart:dsNoOfCol]

        #paste combines the vectors into one string
        #("number of samples: 234" for example)
        print(paste("number of samples: ", dsNoOfCol, sep=""))
        print(paste("number of genes: ", dsNoOfRow, sep=""))

        # calculating the variances
        print(paste("Begin applying Gaussian Mixture Modeling to real data",
            "may take several minutes"))

        for (i in 1:dsNoOfRow) {
            print(i)
            currGeneExpLevel <- data.min.max[i, expColStart:dsNoOfCol]

            # model the gene using Mclust
            gClust <- mclust::Mclust(t(currGeneExpLevel), G=1:6)

            output <- file(paste(filePrefix, "output_pro.txt", sep=""), "at")
            cat(rownames(data.min.max)[i], format(gClust$parameters$pro,
                digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefix, "output_mean.txt", sep=""), "at")
            cat(rownames(data.min.max)[i], format(gClust$parameters$mean,
                digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefix, "output_modelNameG.txt",
                sep=""), "at")
            cat(rownames(data.min.max)[i], gClust$G, gClust$modelName,
                file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefix, "output_sigmasq.txt",
                sep=""), "at")
            cat(rownames(data.min.max)[i],
                format(gClust$parameters$variance$sigmasq,
                       digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefix, "output_classification.txt",
                sep=""), "at")
            cat(rownames(data.min.max)[i], gClust$classification,
                file=output, sep="\t")
            cat("\n", file=output)
            close(output)
        }

        print("Gaussian mixture modeling has been applied to your real data")

        ########## PART 3B: Apply GMM to Simu Data  ############

        # Define prefix name for simu data and other parameters for GMM
        expColStart <- 1
        filePrefixsim <- paste(input, "Simu_", sep=".")
        MAX_NO_OF_DIGITS <- 20

        dsNoOfCol <- NCOL(data.sim)
        dsNoOfRow <- NROW(data.sim)

        #Set column names as "number 1" through value of dsNoOfCol
        colnames(data.sim) <- c(expColStart:dsNoOfCol)

        #Stores column numbers into a data frame
        data.sim <- data.sim[, expColStart:dsNoOfCol]

        print(paste("number of samples: ", dsNoOfCol, sep=""))
        print(paste("number of genes: ", dsNoOfRow, sep=""))

        print(paste("Begin applying Gaussian Mixture Modeling to Simulated",
            "Data, may take several minutes"))

        for (i in 1:dsNoOfRow) {
            print(i)
            currGeneExpLevel<- data.sim[i,expColStart:dsNoOfCol]

            # model the gene using Mclust
            gClust <- mclust::Mclust(t(currGeneExpLevel), G=1:6)

            output <- file(paste(filePrefixsim, "output_pro.txt",
                sep=""), "at")
            cat(rownames(data.sim)[i], format(gClust$parameters$pro,
                digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefixsim, "output_mean.txt",
                sep=""), "at")
            cat(rownames(data.sim)[i], format(gClust$parameters$mean,
                digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefixsim, "output_modelNameG.txt",
                sep=""), "at")
            cat(rownames(data.sim)[i], gClust$G, gClust$modelName,
                file=output, sep="\t")
            cat("\n", file=output)
            close(output)

            output <- file(paste(filePrefixsim, "output_sigmasq.txt",
                sep=""), "at")
            cat(rownames(data.sim)[i],
                format(gClust$parameters$variance$sigmasq,
                    digits=MAX_NO_OF_DIGITS), file=output, sep="\t")
            cat("\n", file = output)
            close(output)

            output <- file(paste(filePrefixsim, "output_classification.txt",
                sep=""), "at")
            cat(rownames(data.sim)[i], gClust$classification,
                file=output, sep="\t")
            cat("\n", file = output)
            close(output)
        }

        print(paste("Gaussian Mixture Modeling has been applied to",
            "your simulated data"))

        ####### PART 4: Determine GMM/TRank estimated number of Genes #######

        # Function that sorts a matrix
        mat.sort <- function(mat,n) {
            mat[rank(as.numeric(mat[,n]),
                ties.method="random"),] <- mat[c(1:nrow(mat)),]
            return(mat)
        }

        # Function to compute the TRank value
        compute.TRank <- function(fn.dataModelNameG,
            fn.dataClassification, fn.dataSigmasq, fn.dataMean,
            fn.dataPro,curr.Sigmasq) {
            # Model Name and G
            dataModelNameG <- utils::read.delim2(fn.dataModelNameG,
                header=FALSE, row.names=1, sep="\t", quote="\"",
                    dec=".", fill=TRUE)

            # discrete classification produced by mclust
            dataClassification <- utils::read.delim2(fn.dataClassification,
                header=FALSE, row.names=1, sep="\t", quote="\"",
                    dec=".", fill=TRUE)

            # Extract Properties of the input file
            # Number of genes
            noOfGene <- NROW(dataModelNameG)
            # Maximum number of gaussians
            maxG <-max(dataModelNameG[, 1])
            # Number of samples
            noOfSample <- NCOL(dataClassification)

            # sigma square produced by mclust
            dataSigmasq <- utils::read.delim2(fn.dataSigmasq,
                header=FALSE, row.names=1, col.names=c(1:(maxG + 1)),
                    sep="\t", quote="\"", dec=".", fill=TRUE)

            # mean produced by mclust
            dataMean <- utils::read.delim2(fn.dataMean,
                header=FALSE, row.names=1, col.names=c(1:(maxG + 1)),
                    sep="\t", quote="\"", dec=".", fill=TRUE)

            # pi-zero produced by mclust
            dataPro <- utils::read.delim2(fn.dataPro,
                header=FALSE, row.names=1, col.names=c(1:(maxG + 1)),
                    sep="\t", quote="\"", dec=".", fill=TRUE)

            # discrete classification produced by mclust
            dataClassification <- utils::read.delim2(fn.dataClassification,
                header=FALSE, row.names=1, col.names=c(1:(noOfSample + 1)),
                    sep="\t", quote="\"", dec=".", fill=TRUE)

            #-------------------------------------------------------
            # This matrix stores the gene selection criteria
            #-------------------------------------------------------
            allCriteria <- matrix(nrow=noOfGene, ncol=8)
            print("Begin computing TRank value")
            #-------------------------------------------------------
            #	Calculating the gene selection criteria
            #-------------------------------------------------------
            for (i in 1:noOfGene) {
                print(paste("Now processing Gene ", i))

                # Get the model information.
                # Extract the number of clusters and model name for each gene
                tmpMMADBID <- as.character(rownames(dataModelNameG[i,]))
                tmpG <- dataModelNameG[i, 1]
                tmpModelName <- as.character(dataModelNameG[i, 2])

                # Temporary MATRIX variables to store the statistical criteria
                tmpPWT <- matrix(data=0, nrow=tmpG, ncol=tmpG)
                #-----------------------------------------------------------
                # Calculate the MIN & MAX proportion (pi-zero)
                #-----------------------------------------------------------
                if(tmpG > 1) {
                    tmpMinPro <- min(as.numeric(dataPro[tmpMMADBID, 1:tmpG]))
                    tmpMaxPro <- max(as.numeric(dataPro[tmpMMADBID, 1:tmpG]))

                    #Added to capture the min and max mean (15 July 2011)
                    tmpMinMean <- min(as.numeric(dataMean[tmpMMADBID, 1:tmpG]))
                    tmpMaxMean <- max(as.numeric(dataMean[tmpMMADBID, 1:tmpG]))
                }

                else {
                    tmpMinPro <- 0
                    tmpMaxPro <- 0

                    #Added to capture the min and max mean (15 July 2011)
                    tmpMinMean <- min(as.numeric(dataMean[tmpMMADBID, 1]))
                    tmpMaxMean <- max(as.numeric(dataMean[tmpMMADBID, 1]))
                }

                #-----------------------------------------------
                # Experiment (9) - sum(pair-wised)
                #-----------------------------------------------

                for(j in 1:(tmpG - 1)) {
                    if(tmpModelName == "X") {
                        # do nothing here
                    }
                    else {
                        for(k in (j + 1):(tmpG - 1)) {
                            # added on 15 July 2011, otherwise wrong.
                            if(k > j) {
                                if(tmpModelName == "E") {
                                    tmpPWT[j, k] <- (abs(dataMean[tmpMMADBID,j]
                                    - dataMean[tmpMMADBID,k]) /
                                    sqrt(2 * dataSigmasq[tmpMMADBID, 1] +
                                    curr.Sigmasq)) * ((dataPro[tmpMMADBID, j] *
                                    dataPro[tmpMMADBID, k]) /
                                    ((dataPro[tmpMMADBID, j] +
                                    dataPro[tmpMMADBID, k]) ^ 2))
                                }
                                else if(tmpModelName == "V") {
                                    tmpPWT[j, k] <- (abs
                                    (dataMean[tmpMMADBID, j] -
                                    dataMean[tmpMMADBID, k]) /
                                    sqrt(dataSigmasq[tmpMMADBID, j] +
                                    dataSigmasq[tmpMMADBID, k] +
                                    curr.Sigmasq)) * ((dataPro[tmpMMADBID, j] *
                                    dataPro[tmpMMADBID, k]) /
                                    ((dataPro[tmpMMADBID, j] +
                                    dataPro[tmpMMADBID, k]) ^ 2))
                                }
                            }
                        }
                    }
                }

                # store all criteria
                allCriteria[i, 1] <- tmpMMADBID
                allCriteria[i, 2] <- tmpG
                allCriteria[i, 3] <- tmpModelName
                allCriteria[i, 4] <- tmpMinPro
                allCriteria[i, 5] <- tmpMaxPro
                #allCriteria[i, 6] = max(as.numeric(tmpPWT))# max
                allCriteria[i, 6] <- sum(as.numeric(tmpPWT))	# sum
                #Added to capture the min and max mean (15 July 2011)
                allCriteria[i, 7] <- tmpMinMean
                allCriteria[i, 8] <- tmpMaxMean
            }

            #-----------------------------------------------------------
            # sort the matrix by one of the allCriteria
            #-----------------------------------------------------------
            sortedAllCriteria <- mat.sort(allCriteria, 6)
            return (sortedAllCriteria)
        }

        #-------------------------------------------
        #	Global constants
        #-------------------------------------------
        MAX_NO_OF_DIGITS <- 20

        # Read in simu data files for TRank calculation
        tmp.fn.dataModelNameG <- paste(filePrefixsim,
            "output_modelNameG.txt", sep="")
        tmp.fn.dataClassification <- paste(filePrefixsim,
            "output_classification.txt", sep="")
        tmp.fn.dataSigmasq <- paste(filePrefixsim,
            "output_sigmasq.txt", sep="")
        tmp.fn.dataMean <- paste(filePrefixsim,
            "output_mean.txt", sep="")
        tmp.fn.dataPro <- paste(filePrefixsim,
            "output_pro.txt", sep="")

        # Calculate the fudge factor for the simu data
        aS0 <- NULL
        currData <- NULL
        for(i in 1:NROW(data.sim)) {
            currData <- as.numeric(data.sim[i,])
            aS0 <- c(aS0,stats::var(currData))
        }

        tmp.Sigmasq <- stats::median(aS0)
        print(paste("The simulated sigamasq is: ", tmp.Sigmasq, sep=""))

        # Call TRank function to calculate simulated data TRank scores
        x <- compute.TRank(tmp.fn.dataModelNameG, tmp.fn.dataClassification,
            tmp.fn.dataSigmasq, tmp.fn.dataMean, tmp.fn.dataPro, tmp.Sigmasq)
        rownames(x) <- as.character(t(x[, 1]))

        # Begin reading in real data files for TRank calculation
        tmp.fn.dataModelNameG <- paste(filePrefix,
            "output_modelNameG.txt", sep="")
        tmp.fn.dataClassification <- paste(filePrefix,
            "output_classification.txt", sep="")
        tmp.fn.dataSigmasq <- paste(filePrefix,
            "output_sigmasq.txt", sep="")
        tmp.fn.dataMean <- paste(filePrefix,
            "output_mean.txt", sep="")
        tmp.fn.dataPro <- paste(filePrefix,"output_pro.txt", sep = "")

        #calculating the fuge factor s0 for real data
        aS0 <- NULL
        currData <- NULL

        for(i in 1:NROW(data.min.max)) {
            currData <- as.numeric(data.min.max[i,])
            aS0 <- c(aS0,stats::var(currData))
        }

        tmp.Sigmasq <- stats::median(aS0)
        print(paste("The real sigamasq is: ", tmp.Sigmasq, sep=""))

        # Call TRank function to calculate TRank scores for real data
        y <- compute.TRank(tmp.fn.dataModelNameG, tmp.fn.dataClassification,
            tmp.fn.dataSigmasq, tmp.fn.dataMean, tmp.fn.dataPro, tmp.Sigmasq)
        rownames(y) <- as.character(t(y[, 1]))

        # Store TRank scores for simu (x.score) and real data (y.score)
        x.score <- as.numeric(t(x[, 6]))
        y.score <- as.numeric(t(y[, 6]))

        #FDR calculations
        maxScore <- max(c(x.score, y.score))
        currCutoff <- min(c(x.score, y.score))
        FDR <- NULL
        bin.size <- 0.001

        while(currCutoff <= maxScore) {
            a <- sum(x.score > currCutoff)
            b <- sum(y.score > currCutoff)
            currFDR <- a / b
            FDR <- rbind(FDR, c(a, b, currCutoff, currFDR))
            currCutoff <- currCutoff + bin.size
        }

        # Choose the TRank with a FDR value of 0.01 for the lowest number
            # of selected genes a represents the index of the TRank
            # value to be chosen

        FDRvalue <- cutoff
        index <- which(FDR[, 4] >= FDRvalue)

        # Conditional if FDR value never reaches specified value
        # Reduce the FDRvalue

        if (length(index) == 0) {
            index <- which(FDR[, 4] >= (FDRvalue / 10))
            if (length(index) == 0) {
                index <- which(FDR[, 4] >= (FDRvalue / 50))
                if (length(index) == 0) {
                    index <- which(FDR[, 4] >= (FDRvalue / 100))
                    if (length(index) == 0) {
                        index <- which(FDR[, 4] >= (FDRvalue / 1000))
                    }
                }
            }
        }

        genenum <- max(index)
        TRank <- FDR[genenum, 3]
        # Conditionals to make sure only one TRank value is chosen
        if (length(TRank) == 0) {
            TRank <- 0.30
            print("Arbitrary TRank value of 0.30 chosen")
            print("The specified FDR cutoff did not occur in the data")
        }

        # Conditional if more than 1 TRank value exists with the FDR cutoff
        if (length(TRank) > 1) {
            TRank <- min(TRank)
        }
        # Save the TRank determined genes to object
        sel.Probe <- as.character(y[as.numeric(y[, 6]) >= TRank, 1])
        gene_num3 <- length(sel.Probe)
        print(paste("The adaptive gene probe number is: ", gene_num3, sep=""))
        return(gene_num3)
    }

}

############# V. Clustering Option ##############
#' Function to perform Kmeans or Hierarchical clustering analysis of the
#' selected gene probe expression data.
#' @param sel.exp Object containing the numeric selected gene expression
#' matrix. This object is an output of the probe_ranking function.
#' @param cluster_type String indicating the type of clustering method to use.
#' "Kmeans" or "HClust" are the two options. The default is set to "HClust".
#' @param seed A positive integer vector >1 indicating a random starting position
#' for the centers of the clusters to be used for the k-means clustering
#' algorithm. The default value is set to NULL and is not used when
#' Hierarchical clustering is chosen.
#' @param distance String describing the distance metric to use for
#' the dist function during hierarchical clustering. dist uses a default
#' distance metric of Euclidean distance. Options include one of "euclidean",
#' "maximum", manhattan", "canberra", "binary", or "minkowski". Kmeans
#' clustering does not use a distance metric. The default value is set
#' to "euclidean".
#' @param linkage_type String describing the linkage metric to be
#' used for HClust. The default is set to "ward.D2", however other options
#' include "average", "complete", "median", "centroid",
#' "single", and "mcquitty".
#' @param gene_distance String describing the distance measure to be used for
#' the Dist function when performing hierarchical clustering of genes.
#' Options include one of "euclidean", "maximum", "manhattan", "canberra",
#' "binary", "pearson", "abspearson", "correlation", "abscorrelation",
#' "spearman" or "kendall". The default of gene_distance is set
#' to "correlation". The deafult value is set to "correlation".
#' The argument can be set to NULL when Kmeans clustering is used.
#' @param num_clusters Positive integer to specify the number of clusters
#' samples will be divided into. This number is determined by the
#' number_clusters function.
#' @param data_name String indicating the cancer type and name of the
#' dataset being analyzed. This name will be used to label the sample
#' dendrograms and heatmap files.
#' @param probe_rank String indicating the feature selection method used
#' in the probe_ranking function. Options include "CV_Rank", "CV_Guided",
#' "SD_Rank", and "Poly".
#' @param probe_num_selection String indicating the way in which probes
#' were selected in the number_probes function. Options include
#' "Fixed_Probe_Num", "Percent_Probe_Num", and "Adaptive_Probe_Num".
#' @param cluster_num_selection String indicating how the number of clusters
#' were determined in the number_clusters function. Options include
#' "Fixed_Clust_Num" and "Gap_Statistic".
#' @return Returns a vector containing the sample information and respective
#' cluster number. In addition, this function outpus sample cluster
#' dendrogams, average expression for each probe in each cluster, and
#' heatmap images and Java TreeView files for HClust dendrograms.
#' @seealso \code{\link{probe_ranking}}, \code{\link{number_clusters}},
#' \code{\link{number_probes}}, \code{\link[stats]{hclust}},
#' \code{\link[stats]{kmeans}}, \code{\link[stats]{dist}}
#' @author Nathan Lawlor, Alec Fabbri
#' @examples
#'
#' # Example 1: HClust Analysis
#' # Load in a data file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
#'     package="multiClust")
#' data <- input_file(input=data_file)
#' # Choose 300 genes to select for
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
#'     Percent=NULL, Adaptive=NULL)
#' # Choose the "CV_Rank" Method for gene ranking
#' sel.data <- probe_ranking(input=data_file, probe_number=300,
#'     probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
#' # Choose a fixed cluster number of 3
#' clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)
#'
#' # Call function using HClust parameters
#' hclust_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="HClust",
#'     seed = NULL, distance="euclidean", linkage_type="ward.D2",
#'     gene_distance="correlation", num_clusters=3,
#'     data_name="GSE2034 Breast", probe_rank="CV_Rank",
#'     probe_num_selection="Fixed_Probe_Num",
#'     cluster_num_selection="Fixed_Clust_Num")
#'
#' # Example 2: Kmeans Analysis
#' # Call function for Kmeans parameters
#' kmeans_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="Kmeans",
#'     seed = 1, distance=NULL, linkage_type=NULL, gene_distance=NULL,
#'     num_clusters=3, data_name="GSE2034 Breast",
#'     probe_rank="CV_Rank", probe_num_selection="Fixed_Probe_Num",
#'     cluster_num_selection="Fixed_Clust_Num")
#' @export
cluster_analysis <- function(sel.exp, cluster_type="HClust", seed = NULL,
    distance="euclidean", linkage_type="ward.D2",
    gene_distance="correlation", num_clusters, data_name,
    probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num") {

    # Conditionals to make sure inputs are strings
    if (is.character(cluster_type) == FALSE) {
        stop("Please input string for cluster_type")
    }

    if (is.null(distance) == FALSE) {
        if (is.character(distance) == FALSE) {
            stop("Please input string for distance")
        }
    }

    if (is.null(linkage_type) == FALSE) {
        if (is.character(linkage_type) == FALSE) {
            stop("Please input string for linkage_type")
        }
    }

    if (is.null(gene_distance) == FALSE) {
        if (is.character(gene_distance) == FALSE) {
            stop("Please input string for gene_distance")
        }
    }

    if (is.numeric(num_clusters) == FALSE) {
        stop("Please input integer for num_clusters")
    }

    if (is.character(data_name) == FALSE) {
        stop("Please input string for data_name")
    }

    if (is.character(probe_rank) == FALSE) {
        stop("Please input string for probe_rank")
    }

    if (is.character(probe_num_selection) == FALSE) {
        stop("Please input string for probe_num_selection")
    }

    if (is.character(cluster_num_selection) == FALSE) {
        stop("Please input string for cluster_num_selection")
    }

    # Function to normalize the gene expression matrix
    nor.min.max <- function(x){
        x.min <- min(x)
        x.max <- max(x)
        x <- (x-x.min) / (x.max - x.min)
        return (x)
    }

    # Ensure the selected gene expression matrix is numeric
    colname <- colnames(sel.exp)
    sel.exp <- t(apply(sel.exp, 1, as.numeric))
    colnames(sel.exp) <- colname

    # Normalization of the selected gene expression matrix
    exp.sel <- t(apply(sel.exp, 1, nor.min.max))
    # Code for HClust analysis of data
    if (cluster_type == "HClust") {
        # Hclust analysis, divide samples into cluster number specified
        hc <- stats::hclust(stats::dist(x=t(exp.sel), method=distance),
            method=linkage_type)
        dc <- stats::as.dendrogram(hc)
        op <- graphics::par(mar=c(1,2,2,1) + 0.1)
        dc <- dendextend::set(dc, "branches_k_color", value=1:num_clusters,
            k=num_clusters)

        # Make a vector filled with blank spaces to replace sample
            # names with blank space
        vec <- NULL
        len <- length(labels(dc))
        for (i in 1:len) {
            i <- ""
            vec <- c(vec, i)
        }

        # Make another dendrogram with no labels
        dc1 <- dc
        # Remove labels from this dendrogram
        dc1 <- dendextend::set(dc1, "labels", vec)

        # Output the sample dendrogram to a pdf
        grDevices::pdf(paste(data_name, distance, linkage_type, probe_rank,
            probe_num_selection , cluster_num_selection, "pdf", sep="."))
        graphics::plot(dc1, main=paste(data_name, "Sample Dendrogram",
            sep=" "), ylab="Height")
        graphics::par(op)
        dendextend::rect.dendrogram(dc1, k=num_clusters, border='orange')
        grDevices::dev.off()
        print("Your HClust Sample Dendrogram has been outputted")

        # Output heatmap files to view in Java TreeView
        # Take the mean difference of the selected gene expression matrix
        exp.sel.mean <- apply(sel.exp, MARGIN=1, mean)
        new.exp.sel <- sel.exp - exp.sel.mean

        # Obtain the sample tree file
        hcSample <- stats::hclust(stats::dist(x=t(new.exp.sel),
            method=distance), method=linkage_type)
        ctc::r2atr(hcSample, file=paste(data_name, probe_rank, linkage_type,
            probe_num_selection, cluster_num_selection, "atr", sep="."),
            distance=hcSample$method)

        # Output the gene tree file
        hcGene <- stats::hclust(amap::Dist(x=new.exp.sel,
            method=gene_distance), method=linkage_type)
        ctc::r2gtr(hcGene, file=paste(data_name, probe_rank, linkage_type,
            probe_num_selection, cluster_num_selection, "gtr", sep="."),
            distance=hcGene$method)

        # Output the CDT tree file
        ctc::r2cdt(hcGene, hcSample, new.exp.sel, file=paste(data_name,
            probe_rank, linkage_type, probe_num_selection,
            cluster_num_selection, "cdt", sep="."))
        print(paste("Your atr, gtr, and cdt files have been outputted",
                    "for viewing in Java TreeView"))

        # Divide the samples into respective clusters
        group <- dendextend::cutree(dc, num_clusters,
            order_clusters_as_data=FALSE)
        group <- group[order(names(group))]
        utils::write.csv(group, paste(data_name, cluster_type, distance,
            linkage_type, probe_rank, probe_num_selection,
            cluster_num_selection, "Samples.Clusters.csv"))
        print(paste("A CSV file has been produced containing your sample",
            "and cluster assignment information"))
        # Return sample and cluster information
        return(group)
    }

    # Code for Kmeans clustering analysis
    if (cluster_type == "Kmeans"){
        # Kmeans clustering and plot output
        set.seed(seed)
        exp.sel.k <- stats::kmeans(t(exp.sel), centers=num_clusters, nstart=25)
        kmeans_name <- paste(data_name, probe_rank, probe_num_selection,
            cluster_num_selection,"Kmeans.Plot.pdf", sep = ".")

        # Obtain vector showing which  cluster each sample belongs to
        samp_clusters <- exp.sel.k$cluster
        utils::write.csv(samp_clusters, paste(data_name, cluster_type,
            probe_rank, probe_num_selection, cluster_num_selection,
            "Samples.Clusters.csv"))
        print(paste("A CSV file has been produced containing your sample",
            "and cluster assignment information"))
        return(samp_clusters)
    }
}

########### III. Gene Probe Ranking Options ################
#' Function to select for genes using one of the available gene
#' probe ranking options.
#' @param input String indicating the name of the text file containing
#' the gene expression matrix.
#' @param probe_number Positive integer indicating the number of gene probes
#' to be selected as determined by the number_probes function.
#' @param probe_num_selection String indicating the way in which number of
#' probes were selected for. Options include "Fixed_Probe_Num",
#' "Percent_Probe_Num", and "Adaptive_Probe_Num".
#' @param data.exp The object containing the original gene expression matrix.
#' This matrix is outputted by the input_file function.
#' @param method A string indicating the gene probe ranking method to use.
#' Possible options include "CV_Rank", "CV_Guided", "SD_Rank", and "Poly".
#' The default is set to "SD_Rank".
#' @note CV_Rank is a gene probe ranking method that selects for probes
#' with the highest coefficient of variation within the dataset.
#' CV_Guided is a method that also uses the coefficient of variation of the
#' dataset to select for gene probes. Every probe within the set is then
#' plotted on a mean and standard deviation graph (with SD being the y-axis).
#' A line is plotted starting from the origin with a slope of the coefficient
#' of variation. The mean and standard deviation cutoff moves along this line
#' until an equal or less then number of desired probes is above the cutoff.
#' SD_Rank is a gene probe ranking method that selects for probes with the
#' highest standard deviation within the dataset.
#' Poly is a ranking method that fits three second degree polynomial
#' functions of mean and standard deviation to the dataset to select
#' the most variable probes in the dataset.
#' @return An object containing the selected gene expression matrix for
#' a particular ranking method. In addition a text file containing the
#' selected gene expression data is produced.
#' @seealso \code{\link{number_probes}}, \code{\link{input_file}}
#' @author Peiyong Guan, Alec Fabbri, Nathan Lawlor
#' @examples
#' # Producing a selected gene expression matrix using one of the
#'    # probe ranking options
#' # Load in a test file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
#'     package="multiClust")
#' data <- input_file(data_file)
#' selected_probes <- probe_ranking(input=data_file, probe_number=300,
#'    probe_num_selection="Fixed_Probe_Num", data.exp=data, method="SD_Rank")
#' @export
probe_ranking <- function(input, probe_number,
    probe_num_selection="Fixed_Probe_Num", data.exp, method="SD_Rank") {

    WriteMatrixToFile <- function(tmpMatrix, tmpFileName,
        blnRowNames, blnColNames) {
        output <- file(tmpFileName, "at")
        utils::write.table(tmpMatrix, output, sep="\t", quote=FALSE,
            row.names=blnRowNames, col.names=blnColNames)
        close(output)
    }

    #Makes Expression Data Numeric
    colname <- colnames(data.exp)
    data.exp <- t(apply(data.exp, 1, as.numeric))
    colnames(data.exp) <- colname

    # If CV_Rank option is chosen
    if (method == "CV_Rank") {
        #Mean and SD Filter
        row.sd <- apply(data.exp, 1, stats::sd)
        row.mean <- apply(data.exp, 1, mean)
        row.cv <- row.sd / row.mean

        # Obtain new gene expression matrix of CV-ranked genes
        data.exp <- data.frame(data.exp, row.cv)
        data.exp <- data.exp[order(data.exp[, dim(data.exp)[2]],
            decreasing=TRUE),]
        data.exp <- data.exp[, -dim(data.exp)[2]]
        newexp.cv <- data.exp[1:probe_number,]
        WriteMatrixToFile(newexp.cv, paste(input, probe_num_selection,
            "CV_Rank_Selected_Gene_Exp.txt", sep="."), TRUE, TRUE)
        print(paste("The selected CV_Rank Gene Expression text file",
            "has been written"))
        return(newexp.cv)
    }

    # If CV_Guided method is chosen
    if (method == "CV_Guided") {
        # Shift the data by the minimum value
        num <- min(data.exp)
        transinput <- data.exp - num

        # Obtain selected gene matrix
        constant <- stats::sd(transinput) / mean(transinput)
        row.sd <- apply(transinput, 1, stats::sd)
        row.mean <- apply(transinput, 1, mean)
        x <- 0
        y <- 55000
        while (y > probe_number) {
            y <- length(which(row.mean > (0.0001 *x) &
                row.sd > (0.0001* constant *x)))
            x <- x + 1
        }
        x <- x - 1

        selmatrix <- transinput[row.mean > (0.0001 *x) &
            row.sd > (.0001 * constant * x),]
        WriteMatrixToFile(selmatrix, paste(input, probe_num_selection,
            "CV_Guided_Selected_Gene_Exp.txt", sep='.'), TRUE, TRUE)
        print(paste("The selected CV_Guided Gene Expression",
            "text file has been written"))
        return(selmatrix)
    }

    if (method == "SD_Rank") {
        # Shift the data by the minimum value
        num <- min(data.exp)
        transinput <- data.exp - num

        # Get selected gene expression matrix
        row.sd <- apply(transinput, 1, stats::sd)
        transinput <- data.frame(transinput, row.sd)
        transinput <- transinput[order(transinput[, dim(transinput)[2]],
            decreasing = TRUE),]
        transinput <- transinput[, -dim(transinput)[2]]
        newexp.sd <- transinput[1:probe_number,]

        WriteMatrixToFile(newexp.sd, paste(input, probe_num_selection,
            "SD_Rank_Selected_Gene_Exp.txt", sep="."), TRUE, TRUE)
        print(paste("The selected SD_Rank Gene Expression",
            "text file has been written"))
        return(newexp.sd)
    }

    if (method == "Poly") {
        # Get mean and standard deviation of each gene
        row.mean <- apply(data.exp, 1, mean)
        row.sd <- apply(data.exp, 1, stats::sd)
        transinput <- data.exp
        # Fit a second degree polynomial to data
        fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
        res <- fit$residuals
        # Determine which genes are above the fitted polynomial
        numgenesel <- length(which(res > 0))
        selgenes <- names(which(res > 0))

        # Obtain the selected gene matrix for genes above the polynomial
        vec <- NULL
        for (i in 1:length(selgenes)) {
            num <- which(rownames(transinput) == selgenes[i])
            vec <- c(vec, num)
        }
        selmatrix <- transinput[vec,]

        # Get mean and sd of new selected gene matrix
        row.mean <- apply(selmatrix, 1, mean)
        row.sd <- apply(selmatrix, 1, stats::sd)

        # Repeat steps and fit second polynomial to data
        fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
        res <- fit$residuals
        numgenesel <- length(which(res > 0))
        selgenes <- names(which(res > 0))

        # Obtain selected gene matrix of genes above the second polynomial fit
        vec <- NULL
        for (i in 1:length(selgenes)) {
            num <- which(rownames(selmatrix) == selgenes[i])
            vec <- c(vec, num)
        }
        selmatrix2 <- selmatrix[vec,]

        # Obtain mean and sd for new genes above the second polynomial fit
        row.mean <- apply(selmatrix2, 1, mean)
        row.sd <- apply(selmatrix2, 1, stats::sd)

        # Fit a third polynomial to the data
        fit <- stats::lm(row.sd ~ poly(row.mean, 2, raw=TRUE))
        res <- fit$residuals

        # Order the genes by highest res number
        df <- data.frame(names(res), res)
        newdf <- df[order(df[,dim(df)[2]], decreasing=TRUE),]

        # Conditional if the user input gene number is larger than the
        # Poly selected amount produce an error prompt
        if (dim(newdf)[1] < probe_number) {
            print(paste("The number of genes determined by the Poly",
                "filter was: ", dim(newdf)[1], sep=""))
          stop("Please choose a gene number equal to or less
              than the determined gene number")
        }

        poly_genes <- newdf[1:probe_number,]
        # Obtain the selected gene matrix for genes above the third polynomial
        selgenes <- rownames(poly_genes)

        vec <- NULL
        for (i in 1:length(selgenes)) {
            num <- which(rownames(selmatrix2) == selgenes[i])
            vec <- c(vec, num)
        }
        selmatrix3 <- selmatrix2[vec,]
        WriteMatrixToFile(selmatrix3, paste(input,
            "Poly_Selected_Gene_Exp.txt", sep="."), TRUE, TRUE)
        print(paste("The selected Poly Gene Expression text",
            "file has been written"))
        return(selmatrix3)
    }

    # Conditional to produce error if user does not choose one
        # of available options
    choices <- c("CV_Rank", "CV_Guided", "SD_Rank", "Poly")
    if (is.na(match(method, choices)) == TRUE) {
        stop("Please choose one of the available methods: CV_Rank,
            CV_Guided, SD_Rank, or Poly")
    }
}

######## Functions to Normalize Data and Write Matrices to Text Files ###############

#' Function to write a data matrix to a text file.
#' @param	 tmpMatrix The object matrix containing data.
#' @param tmpFileName The string name of the text file to write the matrix to.
#' @param blnRowNames Logical value indicating if row names of the matrix should be written
#' along with the matrix.
#' @param blnColNames Logical value indicating if the column names of the matrix should be
#' written with the matrix.
#' @return Text file containing the data matrix.
#' @author Peiyong Guan
#' @seealso \code{\link[utils]{write.table}}
#' @examples
#'
#' #Load sample dataset
#' data(iris)
#' # View sample matrix
#' iris[1:4,1:4]
#' # Write sample matrix to text file
#' WriteMatrixToFile(tmpMatrix = iris, tmpFileName = "iris.sample.matrix.txt",
#' blnRowNames = TRUE, blnColNames = TRUE)
#'
#' @export
WriteMatrixToFile <- function(tmpMatrix, tmpFileName, blnRowNames, blnColNames)
{
  output <- file(tmpFileName, "at")
  utils::write.table(tmpMatrix, output, sep = "\t", quote = FALSE,
              row.names = blnRowNames, col.names = blnColNames)
  close(output)
}

avg_probe_exp <- function(sel.exp, samp_cluster, data_name,
    cluster_type="HClust", distance="euclidean", linkage_type="ward.D2",
    probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num") {

    # Conditionals to make sure inputs are strings
    if (is.character(cluster_type) == FALSE) {
        stop("Please input string for cluster_type")
    }

    if (is.null(distance) == FALSE) {
        if (is.character(distance) == FALSE) {
            stop("Please input string for distance")
        }
    }

    if (is.null(linkage_type) == FALSE) {
        if (is.character(linkage_type) == FALSE) {
            stop("Please input string for linkage_type")
        }
    }

    if (is.character(data_name) == FALSE) {
        stop("Please input string for data_name")
    }

    if (is.character(probe_rank) == FALSE) {
        stop("Please input string for probe_rank")
    }

    if (is.character(probe_num_selection) == FALSE) {
        stop("Please input string for probe_num_selection")
    }

    if (is.character(cluster_num_selection) == FALSE) {
        stop("Please input string for cluster_num_selection")
    }

    # Function to write matrix to text file
    WriteMatrixToFile <- function(tmpMatrix, tmpFileName,
        blnRowNames, blnColNames) {
        output <- file(tmpFileName, "at")
        utils::write.table(tmpMatrix, output, sep="\t", quote=FALSE,
            row.names=blnRowNames, col.names=blnColNames)
        close(output)
    }

    # Make gene matrix numeric
    colname <- colnames(sel.exp)
    sel.exp <- t(apply(sel.exp, 1, as.numeric))
    colnames(sel.exp) <- colname

    # Maximum number of clusters
    numofclust <- max(samp_cluster)
    # Produce a matrix with average gene expression in each cluster
    meansofclust <- NULL
    names <- NULL

    for (i in 1:numofclust) {
        # names contains the column names specifying the cluster number
        names <- c(names, paste('Cluster', i, sep=' '))
        # savednames contains samples that belong to a given cluster number
        savednames <- which(samp_cluster == i)
        vec <- NULL
        for (i in 1:length(savednames)) {
            # match all the sample names in the selected exp file
            # with sample names from savednames
            num <- which(colnames(sel.exp) == names(savednames)[i])
            # Vec will hold all indices of the sample names
            vec <- c(vec, num)
        }
        snipexp = sel.exp[,vec]
        # If statement to catch if only one sample in the cluster
        if (is.null(dim(snipexp)[1]) == TRUE) {
            row.mean <- snipexp
        } else {
            row.mean <- apply(snipexp, 1, mean)
        }
        meansofclust <- rbind(meansofclust, row.mean)
    }

    meansofclust <- t(meansofclust)
    colnames(meansofclust) <- names
    # Write matrix to file
    WriteMatrixToFile(meansofclust, paste(data_name, cluster_type, distance,
        linkage_type, probe_rank, probe_num_selection,
        cluster_num_selection, "Avg.Exp.txt", sep="."), TRUE, TRUE)
    print(paste("Your matrix containing the average gene probe expression",
        "in each cluster is finished"))
    return(meansofclust)
}

# Make a test matrix
test_data <- c(1:8)
test_matrix <- matrix(data=test_data, nrow=2, ncol=4)
samples <- c("a", "b", "c,", "d")

test_avg_probe_exp <- function() {
    checkException(avg_probe_exp(sel.exp=test_matrix, samp_cluster=samples,
    cluster_type=1, distance="euclidean", linkage_type="ward.D2",
    data_name="word", probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num"))
}

## VI. Average Expression of Each Gene Probe in Each Sample Cluster ##
#' Function to produce a matrix containing the average expression of each
#' gene probe within each sample cluster.
#' @param sel.exp Object containing the numeric selected gene
#' expression matrix. This object is an output of the probe_ranking function.
#' @param samp_cluster Object vector containing the samples and the cluster
#' number they belong to. This is an output of the cluster_analysis function.
#' @param data_name String indicating the cancer type and name of the
#' dataset being analyzed. This name will be used to label the sample
#' dendrograms and heatmap files.
#' @param cluster_type String indicating the type of clustering method
#' used in the cluster_analysis function. "Kmeans" or "HClust"
#' are the two options.
#' @param distance String describing the distance metric uses for HClust in
#' the cluster_analysis function. Options include one of "euclidean",
#' "maximum", manhattan", "canberra", "binary", or "minkowski".
#' @param linkage_type String describing the linkage metric used in the
#' cluster_analysis function. Options include "ward.D2", "average",
#' "complete", "median", "centroid", "single", and "mcquitty".
#' @param probe_rank String indicating the feature selection method used
#' in the probe_ranking function. Options include "CV_Rank", "CV_Guided",
#' "SD_Rank", and "Poly".
#' @param probe_num_selection String indicating the way in which probes
#' were selected in the number_probes function. Options include
#' "Fixed_Probe_Num", "Percent_Probe_Num", and "Adaptive_Probe_Num".
#' @param cluster_num_selection String indicating how the number of
#' clusters were determined in the number_clusters function. Options include
#' "Fixed_Clust_Num" and "Gap_Statistic".
#' @author Nathan Lawlor, Alec Fabbri
#' @seealso \code{\link{number_clusters}}, \code{\link{number_probes}},
#' \code{\link{probe_ranking}}, \code{\link{cluster_analysis}}
#' @return Returns an object matrix with the average mean expression for
#' each probe in each sample cluster. Also outputs the object to a text file.
#' @examples
#' # Produce matrix of average expression of each probe in each cluster
#' # Load in a data file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
#'     package="multiClust")
#' data <- input_file(input=data_file)
#' # Choose 300 genes to select for
#' gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
#'    Percent=NULL, Adaptive=NULL)
#' # Choose the "CV_Rank" Method for gene ranking
#' sel.data <- probe_ranking(input=data_file, probe_number=300,
#'     probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
#' # Choose a fixed cluster number of 3
#' clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)
#' # Call function for Kmeans parameters
#' kmeans_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="Kmeans",
#'     distance=NULL, linkage_type=NULL, gene_distance=NULL,
#'     num_clusters=3, data_name="GSE2034 Breast",
#'     probe_rank="CV_Rank", probe_num_selection="Fixed_Probe_Num",
#'     cluster_num_selection="Fixed_Clust_Num")
#' # Call function for average matrix expression calculation
#' avg_matrix <- avg_probe_exp(sel.exp=sel.data, samp_cluster=kmeans_analysis,
#'     data_name="GSE2034 Breast", cluster_type="Kmeans", distance=NULL,
#'     linkage_type=NULL, probe_rank="CV_Rank",
#'     probe_num_selection="Fixed", cluster_num_selection="Fixed_Clust_Num")
#' @export

avg_probe_exp <- function(sel.exp, samp_cluster, data_name,
    cluster_type="HClust", distance="euclidean", linkage_type="ward.D2",
    probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num") {

    # Conditionals to make sure inputs are strings
    if (is.character(cluster_type) == FALSE) {
        stop("Please input string for cluster_type")
    }

    if (is.null(distance) == FALSE) {
        if (is.character(distance) == FALSE) {
            stop("Please input string for distance")
        }
    }

    if (is.null(linkage_type) == FALSE) {
        if (is.character(linkage_type) == FALSE) {
            stop("Please input string for linkage_type")
        }
    }

    if (is.character(data_name) == FALSE) {
        stop("Please input string for data_name")
    }

    if (is.character(probe_rank) == FALSE) {
        stop("Please input string for probe_rank")
    }

    if (is.character(probe_num_selection) == FALSE) {
        stop("Please input string for probe_num_selection")
    }

    if (is.character(cluster_num_selection) == FALSE) {
        stop("Please input string for cluster_num_selection")
    }

    # Function to write matrix to text file
    WriteMatrixToFile <- function(tmpMatrix, tmpFileName,
        blnRowNames, blnColNames) {
        output <- file(tmpFileName, "at")
        utils::write.table(tmpMatrix, output, sep="\t", quote=FALSE,
            row.names=blnRowNames, col.names=blnColNames)
        close(output)
    }

    # Make gene matrix numeric
    colname <- colnames(sel.exp)
    sel.exp <- t(apply(sel.exp, 1, as.numeric))
    colnames(sel.exp) <- colname

    # Maximum number of clusters
    numofclust <- max(samp_cluster)
    # Produce a matrix with average gene expression in each cluster
    meansofclust <- NULL
    names <- NULL

    for (i in 1:numofclust) {
        # names contains the column names specifying the cluster number
        names <- c(names, paste('Cluster', i, sep=' '))
        # savednames contains samples that belong to a given cluster number
        savednames <- which(samp_cluster == i)
        vec <- NULL
        for (i in 1:length(savednames)) {
            # match all the sample names in the selected exp file
            # with sample names from savednames
            num <- which(colnames(sel.exp) == names(savednames)[i])
            # Vec will hold all indices of the sample names
            vec <- c(vec, num)
        }
        snipexp = sel.exp[,vec]
        # If statement to catch if only one sample in the cluster
        if (is.null(dim(snipexp)[1]) == TRUE) {
            row.mean <- snipexp
        } else {
            row.mean <- apply(snipexp, 1, mean)
        }
        meansofclust <- rbind(meansofclust, row.mean)
    }

    meansofclust <- t(meansofclust)
    colnames(meansofclust) <- names
    # Write matrix to file
    WriteMatrixToFile(meansofclust, paste(data_name, cluster_type, distance,
        linkage_type, probe_rank, probe_num_selection,
        cluster_num_selection, "Avg.Exp.txt", sep="."), TRUE, TRUE)
    print(paste("Your matrix containing the average gene probe expression",
        "in each cluster is finished"))
    return(meansofclust)
}

########## IV. Number of Clusters  ##############
#' Function to determine the number of clusters to be used
#' to cluster gene probes and samples.
#' @param data.exp The numeric original gene expression matrix to be used
#' for clustering of genes and samples. This object is an output
#' of the input_file function.
#' @param Fixed A positive integer used to represent the number of clusters
#' the samples and probes will be divided into. The default cluster number
#' is set to 3 clusters.
#' @param gap_statistic A logical indicating whether to use the
#' gap_statistic to determine the optimal number of clusters to
#' divide samples into.
#' @note The user should only choose either the fixed or gap_statistic
#' option, not both. When using the gap_statistic option, change the
#' argument to TRUE and "Fixed" to NULL.
#' @return An object with the determined number of clusters to use.
#' @author Nathan Lawlor, Alec Fabbri
#' @seealso \code{\link[cluster]{clusGap}}, \code{\link{probe_ranking}}
#' @examples
#'
#' #Example 1: Using a fixed cluster number
#' # Load in a test file
#' data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
#' package="multiClust")
#' data <- input_file(data_file)
#' clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)
#'
#' \dontrun{
#' # Example 2: Using the gap_statistic to determine the optimal cluster number
#' # Computation time is somewhat long
#' clust_num <- number_clusters(data.exp=data, Fixed=NULL, gap_statistic=TRUE)
#'  }
#' @export
number_clusters <- function(data.exp, Fixed=3, gap_statistic=NULL){
    # Conditional to cause error if user chooses both Fixed and
        #gap_statistic method
    if (is.null(Fixed) == FALSE) {
        if (is.null(gap_statistic) == FALSE) {
            stop("Please choose one of the two options
                (Fixed or gap_statistic) only")
        }
    }

    if (is.null(Fixed) == FALSE) {
        if (is.numeric(Fixed) == TRUE) {
            cluster_num <- Fixed
            print(paste("The fixed cluster number is: ", cluster_num, sep=""))
            return(cluster_num)
        } else {
            stop("Please input an integer for Fixed")
        }
    }

    if (gap_statistic == TRUE) {
        #Makes Expression Data Numeric
        colname <- colnames(data.exp)
        data.exp <- t(apply(data.exp, 1, as.numeric))
        colnames(data.exp) <- colname

        # Transpose the matrix to do the gap_stat calculation by columns
        # clusGap function calculates by rows
        theGap <- cluster::clusGap(t(data.exp),
            FUNcluster=stats::kmeans, K.max=8)
        # This returns a table with K.max rows and 4 other columns
        # The maximum "gap" value corresponds to the optimal cluster number
        gapDF <- as.data.frame(theGap$Tab)
        # Make a new data frame of cluster number and gap statistic
        clust_total <- c(1:dim(gapDF)[1])
        gap_and_clust <- data.frame(clust_total, gapDF[, "gap"])
        # Determine which is maximum gap statistic
        max_gap <- max(gap_and_clust[,2])
        # Obtain cluster number with maximum gap statistic
        cluster_num2 <- which(gap_and_clust[,2] == max_gap)
        print(paste("The gap statistic cluster number is: ",
            cluster_num2, sep=""))
        return(cluster_num2)
    }
}

cluster_analysis <- function(sel.exp, cluster_type="HClust",
    distance="euclidean", linkage_type="ward.D2",
    gene_distance="correlation", num_clusters, data_name,
    probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num") {

  # Conditionals to make sure inputs are strings
  if (is.character(cluster_type) == FALSE) {
    stop("Please input string for cluster_type")
  }

  if (is.null(distance) == FALSE) {
    if (is.character(distance) == FALSE) {
      stop("Please input string for distance")
    }
  }

  if (is.null(linkage_type) == FALSE) {
    if (is.character(linkage_type) == FALSE) {
      stop("Please input string for linkage_type")
    }
  }

  if (is.null(gene_distance) == FALSE) {
    if (is.character(gene_distance) == FALSE) {
      stop("Please input string for gene_distance")
    }
  }

  if (is.numeric(num_clusters) == FALSE) {
    stop("Please input integer for num_clusters")
  }

  if (is.character(data_name) == FALSE) {
    stop("Please input string for data_name")
  }

  if (is.character(probe_rank) == FALSE) {
    stop("Please input string for probe_rank")
  }

  if (is.character(probe_num_selection) == FALSE) {
    stop("Please input string for probe_num_selection")
  }

  if (is.character(cluster_num_selection) == FALSE) {
    stop("Please input string for cluster_num_selection")
  }

  # Function to normalize the gene expression matrix
  nor.min.max <- function(x){
    x.min <- min(x)
    x.max <- max(x)
    x <- (x-x.min) / (x.max - x.min)
    return (x)
  }

  # Ensure the selected gene expression matrix is numeric
  colname <- colnames(sel.exp)
  sel.exp <- t(apply(sel.exp, 1, as.numeric))
  colnames(sel.exp) <- colname

  # Normalization of the selected gene expression matrix
  exp.sel <- t(apply(sel.exp, 1, nor.min.max))
  # Code for HClust analysis of data
  if (cluster_type == "HClust") {
    # Hclust analysis, divide samples into cluster number specified
    hc <- stats::hclust(stats::dist(x=t(exp.sel), method=distance),
        method=linkage_type)
    dc <- stats::as.dendrogram(hc)
    op <- graphics::par(mar=c(1,2,2,1) + 0.1)
    dc <- dendextend::set(dc, "branches_k_color", value=1:num_clusters,
        k=num_clusters)

    # Make a vector filled with blank spaces to replace sample
    # names with blank space
    vec <- NULL
    len <- length(labels(dc))
    for (i in 1:len) {
      i <- ""
      vec <- c(vec, i)
    }

    # Make another dendrogram with no labels
    dc1 <- dc
    # Remove labels from this dendrogram
    dc1 <- dendextend::set(dc1, "labels", vec)

    # Output the sample dendrogram to a pdf
    grDevices::pdf(paste(data_name, distance, linkage_type, probe_rank,
        probe_num_selection , cluster_num_selection, "pdf", sep="."))
    graphics::plot(dc1, main=paste(data_name, "Sample Dendrogram",
        sep=" "), ylab="Height")
    graphics::par(op)
    dendextend::rect.dendrogram(dc1, k=num_clusters, border='orange')
    grDevices::dev.off()
    print("Your HClust Sample Dendrogram has been outputted")

    # Output heatmap files to view in Java TreeView
    # Take the mean difference of the selected gene expression matrix
    exp.sel.mean <- apply(sel.exp, MARGIN=1, mean)
    new.exp.sel <- sel.exp - exp.sel.mean

    # Obtain the sample tree file
    hcSample <- stats::hclust(stats::dist(x=t(new.exp.sel),
        method=distance), method=linkage_type)
    ctc::r2atr(hcSample, file=paste(data_name, probe_rank, linkage_type,
        probe_num_selection, cluster_num_selection, "atr", sep="."),
        distance=hcSample$method)

    # Output the gene tree file
    hcGene <- stats::hclust(amap::Dist(x=new.exp.sel,
        method=gene_distance), method=linkage_type)
    ctc::r2gtr(hcGene, file=paste(data_name, probe_rank, linkage_type,
        probe_num_selection, cluster_num_selection, "gtr", sep="."),
        distance=hcGene$method)

    # Output the CDT tree file
    ctc::r2cdt(hcGene, hcSample, new.exp.sel, file=paste(data_name,
        probe_rank, linkage_type, probe_num_selection,
                                                         cluster_num_selection, "cdt", sep="."))
    print(paste("Your atr, gtr, and cdt files have been outputted",
                "for viewing in Java TreeView"))

    # Divide the samples into respective clusters
    group <- dendextend::cutree(dc, num_clusters,
                                order_clusters_as_data=FALSE)
    group <- group[order(names(group))]
    utils::write.csv(group, paste(data_name, cluster_type, distance,
        linkage_type, probe_rank, probe_num_selection,
        cluster_num_selection, "Samples.Clusters.csv"))
    print(paste("A CSV file has been produced containing your sample",
        "and cluster assignment information"))
    # Return sample and cluster information
    return(group)
  }

  # Code for Kmeans clustering analysis
  if (cluster_type == "Kmeans"){
    # Kmeans clustering and plot output
    set.seed(1293075)
    exp.sel.k <- stats::kmeans(t(exp.sel), centers=num_clusters, nstart=25)
    kmeans_name <- paste(data_name, probe_rank, probe_num_selection,
        cluster_num_selection,"Kmeans.Plot.pdf", sep = ".")

    # Obtain vector showing which  cluster each sample belongs to
    samp_clusters <- exp.sel.k$cluster
    utils::write.csv(samp_clusters, paste(data_name, cluster_type,
        probe_rank, probe_num_selection, cluster_num_selection,
        "Samples.Clusters.csv"))
    print(paste("A CSV file has been produced containing your sample",
        "and cluster assignment information"))
    return(samp_clusters)
  }
}

# Make a test matrix
test_data <- c(1:8)
test_matrix <- matrix(data=test_data, nrow=2, ncol=4)

test_cluster_analysis <- function() {
    checkException(cluster_analysis(sel.exp=test_matrix, cluster_type=1,
        distance="euclidean", linkage_type="ward.D2",
        gene_distance="correlation", num_clusters=3, data_name="word",
        probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
        cluster_num_selection="Fixed_Clust_Num"))
}

---
title: "A Guide to multiClust"
author: "Nathan Lawlor"
date: '`r Sys.Date()`'
output:
  html_document:
    toc: yes
    toc_depth: 6
  pdf_document:
    toc: yes
vignette: |
  %\VignetteIndexEntry{"A Guide to multiClust"}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Introduction

Whole transcriptomic profiles are useful for studying the expression levels
of thousands of  genes across samples. Clustering algorithms are used to 
identify patterns in these profiles to determine clinically relevant
subgroups. Feature selection is a critical integral part of the process.
Currently, there are many feature selection and clustering methods to identify
the relevant genes and perform clustering of samples. However, choosing the
appropriate methods is difficult as recent work demonstrates that no method is
the clear winner. Hence, we present an R-package called `multiClust` that
allows researchers to experiment with the choice of combination of methods
for gene selection and clustering with ease. In addition, using multiClust,
we present the merit of gene selection and clustering methods in the context
of clinical relevance of clustering, specifically clinical outcome.

Our integrative R-package contains:
  
   1. A function to read in gene expression data and format appropriately for
   analysis in R.
  
   2.	Four different ways to select the number of genes
      a.	Fixed
      b.	Percent
      c.	Poly
      d.	GMM
  
   3.	Four gene ranking options that order genes based on different
   statistical criteria
      a.	CV_Rank
      b.	CV_Guided
      c.	SD_Rank
      d.	Poly

   4.	Two ways to determine the cluster number
      a.	Fixed
      b.	Gap Statistic

   5.	Two clustering algorithms
      a.	Hierarchical clustering
      b.	K-means clustering

   6.	A function to calculate average gene expression in each sample cluster
   7.	A function to correlate sample clusters with clinical outcome

**Function Workflow**

The seven functions listed below should be used in the following order:

   1. `input_file`, a function to read-in a text file containing the matrix
   of gene probes and samples to analyze. 
   
   2. `number_probes`, a function to determine the number of gene probes to
   select for in the feature selection process.
   
   3. `probe_ranking`, a function to rank and select for probes using one of
   the available ranking options.
   
   4. `number_clusters`, a function to determine the number of clusters to be
   used to cluster gene probes and samples.
   
   5. `cluster_analysis`, a function to perform Kmeans or Hierarchical
   clustering analysis of the selected gene probe expression data.
   
   6. `avg_probe_exp`, a function to produce a matrix containing the average
   expression of each gene probe within each sample cluster.
   
   7. `surv_analysis`, a function to produce Kaplan-Meier Survival Plots
   after the discretization of samples into different clusters. 
   
**Other Functions Included**

   * `WriteMatrixToFile`, a function to write a data matrix to a text file.
   
   * `nor.min.max`, a function to that uses feature scaling to normalize
   values in a matrix between 0 and 1.

---

## 1. Getting Started

In order to use `multiClust`, the user will need two text files. 

* The first file is a gene probe expression dataset. This file should be
a matrix with columns being the samples and the rows being genes or probes.

* The second file contains the patient clinical parameters. This file
should be a matrix consisting of two columns. The first column contains
the patient survival time and the second column contains the patient survival
event occurrence. Survival time should be recorded in months. Survival event
occurrence should be indicated by a 0 or 1. A 0 indicates censorship and a 1
indicates an event has occurred.

### 1.1 Obtaining a Gene Expression Dataset and Clinical Information

In this example, a gene expression dataset, GSE2034, will be obtained 
from the Gene Expression Omnibus (GEO) website <http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=gse2034>.

The following code can be used to extract the gene expression data and
clinical information from the series matrix text zip file. When using this
code, be sure that you have a strong internet connection. The GSE
datasets are very large!

```{r, eval=TRUE, message=FALSE}
# Load GEO and biobase libraries
library(GEOquery)
library(Biobase)
library(multiClust)
library(preprocessCore)
library(ctc)
library(gplots)
library(dendextend)
library(graphics)
library(grDevices)
library(amap)
library(survival)
```

```{r, eval=FALSE, message=FALSE}
# Obtain GSE series matrix file from GEO website using getGEO function
gse <- getGEO(GEO="GSE2034")
    
# Save the gene expression matrix as an object
data.gse <- exprs(gse[[1]])
    
# Save the patient clinical data to an object
pheno <- pData(phenoData(gse[[1]]))
    
# Write the gene expression and clinical data to text files
WriteMatrixToFile(tmpMatrix=data.gse, tmpFileName="GSE2034.expression.txt",
    blnRowNames=TRUE, blnColNames=TRUE)
    
WriteMatrixToFile(tmpMatrix=pheno, tmpFileName="GSE2034.clinical.txt",
    blnRowNames=TRUE, blnColNames=TRUE)
    
```

In the event that an error is produced when trying to obtain GSE datasets
from the NCBI GEO FTP site, please use this alternative method:

1. On the NCBI GEO website (<http://www.ncbi.nlm.nih.gov/geo/>), simply
search for the desired dataset (e.g."GSE2034") and scroll down to the
"Analyze with GEO2R" section and click on "Series Matrix Files". 
2. From there, download the series matrix txt.gz file to your computer. 
3. Move the zipped file to a folder of your choice.
4. In R, set your working directory to the directory with the GSE file.
5. In R, read in the downloaded GSE series matrix file.

After downloading the GSE series matrix file and moving it to a directory
the following code can be used.

```{r, eval=FALSE}
# Obtain GSE series matrix file from GEO website using getGEO function
gse <- getGEO(filename="GSE2034_series_matrix.txt.gz")

# Save the gene expression matrix as an object
data.gse <- exprs(gse[[1]])
    
# Save the patient clinical data to an object
pheno <- pData(phenoData(gse[[1]]))
    
# Write the gene expression and clinical data to text files
WriteMatrixToFile(tmpMatrix=data.gse, tmpFileName="GSE2034.expression.txt",
    blnRowNames=TRUE, blnColNames=TRUE)
    
WriteMatrixToFile(tmpMatrix=pheno, tmpFileName="GSE2034.clinical.txt",
    blnRowNames=TRUE, blnColNames=TRUE)
    
```

#### 1.2 Normalization of Gene Expression Datasets

Some datasets on GEO are already normalized using Robust Multichip Average
(RMA) procedure available in the 'affy' R pacakge or quantile normalization
and log2 scaling using the 'preprocessCore' R package. 

For datasets that are not normalized, the following code can be used to
extract the gene expression matrix from the series matrix text file, quantile
normalize the data, log2 scale the data, and lastly write the data to
a text file.

```{r, eval=FALSE}
# Obtain GSE series matrix file from GEO website using getGEo function
gse <- getGEO(GEO="GSE2034")
    
# Save the gene expression matrix as an object
data.gse <- exprs(gse)

# Quantile normalization of the dataset
data.norm <- normalize.quantiles(data.gse, copy=FALSE)

# shift data before log scaling to prevent errors from log scaling
    # negative numbers
if (min(data.norm)> 0) {
    } 
    else {
        mindata.norm=abs(min(data.norm)) + .001
        data.norm=data.norm + mindata.norm  
    }

# Log2 scaling of the dataset
data.log <- t(apply(data.norm, 1, log2))

# Write the gene expression and clinical data to text files
WriteMatrixToFile(tmpMatrix=data.log,
    tmpFileName="GSE2034.normalized.expression.txt",
    blnRowNames=TRUE, blnColNames=TRUE)

```

#### 1.3 Formatting the Patient Clinical Information

As mentioned in the beginning of this section, the patient survival
information file should be a matrix consisting of two columns. However,
when the patient clinical information is written to a text file, it is
generally a matrix of more than two columns with all of the
clinical parameters.

It is recommended that this text file be loaded in R or Microsoft Excel to
obtain the two columns of survival information needed. Below is an example
of what the patient survival information file should look like:

```{r, eval=TRUE}
# Obtain clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")

# Load in survival information file
clinical <- read.delim2(file=clin_file, header=TRUE)

# Display first few rows of the file
clinical[1:5, 1:2]

# Column one represents the survival time in months
# Column two represents the relapse free survival (RFS) event 

```


---

## 2. Loading Your Gene Probe Expression Dataset into R

The first function of `multiClust` is used to load a gene expression dataset
into R and format the matrix so that the probe or gene names are the rownames 
of the matrix.

### 2.1 Loading Text Files Containing Gene Expression Matrix

In this example, the GSE2034 dataset is loaded into the R console using the
`input_file` function.

**Function Arguments**

* This function has one variable called "input" which is the string name
of the gene expression text file to load.

**Example**

```{r, eval=TRUE}
# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt", package= "multiClust")

# Load the gene expression matrix 
data.exprs <- input_file(input=exp_file)

# View the first few rows and columns of the matrix
data.exprs[1:4,1:4]
```

In this example, the gene expression matrix is stored into the
object "data.exprs".

---

## 3. Gene Selection Algorithms

### 3.1 Determining the Number of Desired Probes or Genes

The second function of this package, `number_probes` is a function used to
specify the number of desired probes or genes the user would like to select for
in their gene selection analysis.

**Function Arguments**

* This function has multiple arguments. The first argument "input" represents 
    the string name of the expression matrix text file to be loaded into R.
    
* The second argument "data.exp" is the object containing the expression matrix
    
* The last four arguments "Fixed", "Percent", "Poly", and "Adaptive" 
    are the four different methods that determine how the number of genes are 
    selected. The default option in the function is set to "Fixed".
    
1. **Fixed** is an option where the user provides a positive integer to specify
desired number of genes or probes to select for. The default value of
"Fixed" is set to 1000. If the user writes:

```{r, eval=TRUE}
# Example 1: Choosing a fixed gene or probe number

# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

gene_num <- number_probes(input=exp_file,
    data.exp=data.exprs, Fixed=300,
    Percent=NULL, Poly=NULL, Adaptive=NULL)

```
   
As a result, 300 genes from the dataset will be selected during the gene
or probe selection process.
   
2. **Percent** is another option where the user provides a positive integer 
between 0 and 100 indicating the percentage of total genes or probes to 
select from the dataset. For example, if the dataset has 20,000 total probes 
and the user specifies:
 
```{r, eval=TRUE}
# Example 2: Choosing 50% of the total selected gene probes in a dataset
# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

gene_num <- number_probes(input=exp_file, 
    data.exp=data.exprs, Fixed=NULL,
    Percent=50, Poly=NULL, Adaptive=NULL)

```

As a result, 50% of the total dataset probes, or 300 probes, will be selected.

3. **Poly** is the third option which fits three second degree polynomial
functions to the gene expression dataset based on the dataset's mean
and standard deviation. When the user specifies:

```{r, eval=TRUE}
# Example 3: Choosing the polynomial selected gene probes in a dataset
# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

gene_num <- number_probes(input=exp_file, 
    data.exp=data.exprs, Fixed=NULL,
    Percent=NULL, Poly=TRUE, Adaptive=NULL)

```

4. **Adaptive** is the last option which implements Gaussian mixture
modeling (GMM) to determine the appropriate number of genes or probes
to select for. When the user specifies:
    
```{r, eval=FALSE}
# Example 4: Choosing the Adaptive Gaussian Mixture Modeling method

gene_num <- number_probes(input=exp_file, 
    data.exp=data.exprs, Fixed=NULL,
    Percent=NULL, Poly=NULL, Adaptive=TRUE)

```

The "Mclust" function from the package mclust 
<https://cran.r-project.org/web/packages/mclust/mclust.pdf>
is used to apply Gaussian mixture modeling to the inputted gene expression
matrix. In addition, files containing information about the dataset's
mean, variance, mixing proportion, and gaussian assignment are also outputted. 
   
It should be noted that when choosing one of the three methods of gene or probe
number selection, the other methods should be set equal to "NULL". Furthermore,
the **Adaptive** option has a very long computational time. 

**Function Output**

This function returns an object containing the number of genes/probes to select
for during the feature selection process. 
    
#### 3.2 Choosing a Gene Selection Algorithm

The third function of this package, `probe_ranking` is used to select the most
informative gene probes within a dataset. This function allows the user choose
from one of four different probe ranking algorithms.

**Function Arguments**

* This function has multiple arguments. The first argument "input" represents
the string name of the expression matrix text file to be loaded into R.
    
* The second argument "probe_number" is an output of the `number probes`
function. For this argument, the user specifies the number of genes to
select for.
  
* The third argument "probe_num selection" is a string specifying which
type of probe number selection method was used for the `number_probes`
function. 

* The fourth argument "data.exp" is the object containing the expression
matrix.
  
* The last argument "method" is a string that specifies which of the four
probe ranking methods to use.
    
**List of the Five Probe Ranking Methods**

1. __CV_Rank__ is a gene probe ranking method that selects for probes using
the coefficient of variation of the entire dataset (CV).

2. __CV_Guided__ is a gene probe ranking method that uses the coefficient of
variation (CV) for each probe to select for probes.

3. __SD_Rank__ is a gene probe ranking method that selects for probes with
the highest standard deviation within the dataset.

4. __Poly__ is a ranking method that fits three second degree
polynomial functions of mean and standard deviation to the dataset to select
the most variable probes in the dataset. This is the only method that does
not use a probe number input from the `number_probes` function. When using
this ranking method "probe_num" can be set to NULL.

**Example**

Below is an example of how to use the `probe_ranking` function:

```{r, eval=TRUE}

# Obtain gene expression matrix
exp_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")

# Load the gene expression matrix 
data.exprs <- input_file(input=exp_file)

# Call probe_ranking function
# Select for 500 probes
# Choose genes using the SD_Rank method
ranked.exprs <- probe_ranking(input=exp_file,
    probe_number=300, 
    probe_num_selection="Fixed_Probe_Num",
    data.exp=data.exprs, 
    method="SD_Rank")

# Display the first few columns and rows of the matrix
ranked.exprs[1:4,1:4]

```

**Function Outputs**

The output of this function is a text file containing a selected gene or probe
expression matrix. In addition, the selected expression matrix is stored into
the chosen variable "ranked.exprs". 

---

## 4. Cluster Analysis of Selected Genes and Samples

### 4.1 Determining the Number of Clusters to Divide Samples Into

The fourth function is this package, `number_clusters`, is a function used to
designate the number of clusters that samples will be assigned to. 

**Function Arguments**

1. The "data.exp" argument represents an object containing the original gene
expression matrix to be used for clustering of genes and samples. 
This object is an output of the `input_file` function.

2. The "Fixed" argument is a positive integer used to represent 
the number of clusters the samples and probes will be divided into.

3. The "gap_statistic" argument is a logical indicating whether to calculate
the optimal number of clusters to divide the samples into using a gap
statistic function `clus_Gap` from the package `cluster`. 

**Note**

The user should only choose either the "Fixed" or "gap_statistic" option,
not both. When using the gap_statistic option, change the argument to TRUE
and "Fixed" to NULL.

**Fixed Cluster Number Example**

Below is an example of how to use the `number_clusters` function with a fixed
number of clusters:

```{r, eval=TRUE}

# Call the number_clusters function
# data.exp is the original expression matrix object outputted from
# the input_file function
# User specifies that samples will be separated into 3 clusters 
# with the "Fixed" argument
cluster_num <- number_clusters(data.exp=data.exprs, Fixed=3,
    gap_statistic=NULL)

```


The output from this example will be the object "cluster_num" with
a value of 3. 

**Gap statistic Example**

The `number_clusters` function can be called in a similar way to use the
gap_statistic option:

```{r, eval=FALSE}

# Call the number_clusters function
# data.exp is the original expression matrix object ouputted from
# the input_file function
# User chooses the gap_statistic option by making gap_statistic equal TRUE
# The Fixed argument is also set to NULL
cluster_num <- number_clusters(data.exp=data.exprs, Fixed=NULL,
    gap_statistic=TRUE)

```

The gap_statistic option has a very long computational time and can take 
up to several hours. The output of this function will be a positive integer
indicating the optimal number of clusters to divide samples into.


#### 4.2 Kmeans or Hierarchical Clustering of Genes/Probes and Samples

The fifth function in this package, `cluster_analysis` is a function used
to perform Kmeans or Hierarchical clustering analysis of genes/probes and
samples after undergoing a feature selection process in the `probe_ranking`
function. 

**Function Arguments:**

1. The first argument "sel.exp", is an object containing the numeric selected
gene expression matrix. This object is an output of the `probe_ranking`
function.

2. The second argument "cluster_type" is a string indicating the type of 
clustering method to use. *Kmeans* or *HClust* are the two options.

3. The third argument "distance" is a string describing the distance metric 
to use for Hierarchical clustering via the `dist` function. `dist` uses 
a default distance metric of Euclidean distance. Options include
one of "euclidean", "maximum", manhattan", "canberra", "binary", or 
"minkowski". Kmeans does not use a distance metric.

4. The fourth argument, "linkage_type" is a string describing the linkage
metric to be used for hierarchical clustering in the `hclust` function.
The default is "ward.D2", however other options include "average", "complete",
"median", "centroid", "single", and "mcquitty". Kmeans does not use a 
linkage metric.

5. The fifth argument, "gene_distance" is a string describing the distance
measure to be used for the `Dist` function when performing hierarchical
clustering of genes. Options include one of "euclidean", "maximum",
"manhattan", "canberra", "binary", "pearson", "abspearson", "correlation",
"abscorrelation", "spearman" or "kendall". The default of gene_distance is
set to "correlation". The argument can be set to NULL when Kmeans
clustering is used.

6. The sixth argument "num_clusters" is a positive integer to specify the 
number of clusters samples will be divided into. This number is 
determined by the `number_clusters` function.

7. The seventh argument "data_name" is a string indicating the cancer type 
and/or name of the dataset being analyzed. This name will be used to label 
the sample dendrograms and heatmap files.

8. The eighth argument "probe_rank" is a string indicating the feature 
selection method used in the `probe_ranking` function. Options include
"CV_Rank", "CV_Guided", "SD_Rank", and "Poly".

9. The ninth argument "probe_num_selection" is a string indicating the way 
in which probes were selected in the `number_probes` function. Options 
include "Fixed_Probe_Num", "Percent_Probe_Num", "Poly_Probe_Num", 
and "Adaptive_Probe_Num".

10. The tenth argument, "cluster_num_selection" is a string indicating 
how the number of clusters were determined in the number_clusters function. 
Options include "Fixed_Clust_Num" and "Gap_Statistic".

**Function Outputs**

* A CSV file containing the sample names and their respective cluster. 
An object containing a vector of the sample names and their cluster number
is returned.

* When hierarchical clustering is chosen as the cluster method, a pdf file 
of the sample dendrogram as well as atr, gtr, and cdt files for viewing 
in Java TreeView are outputted. In the Java TreeView heatmap, the samples
are clustered by the method indicated by the "linkage_type" argument
while genes are clustered by the method indicated by the "gene_distance"
argument. The default of sample clustering for the Java TreeView heatmap
is "ward.D2" and the default for gene clustering is centered pearson 
"correlation". 

**Hierarchical Clustering Example**

Below is an example of how to use the `cluster_analysis` function using the 
Hierarchical clustering option:

```{r, eval=TRUE, fig.show='hold', warning=FALSE}

# Call the cluster_analysis function
hclust_analysis <- cluster_analysis(sel.exp=ranked.exprs,
    cluster_type="HClust",
    distance="euclidean", linkage_type="ward.D2", 
    gene_distance="correlation",
    num_clusters=3, data_name="GSE2034 Breast", 
    probe_rank="SD_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")

# Display the first few columns and rows of the object
head(hclust_analysis)

```

**Function Outputs**

The outputs from this example would be an object "hclust_analysis" containing 
a vector of the sample names and cluster number. In addition, a sample
dendrogram pdf file would be written. Lastly, the atr, gtr, and cdt files are 
outputted to view a heatmap of the genes and samples in Java TreeView.

**Note**

The `cluster_analysis` function does not display the sample dendrogram
and heatmap in the console. To show what these images would look like,
the following examples are provided below.

**Java TreeView Heatmap Example**

Below is an example of a heatmap produced in Java TreeView from the atr,
gtr, abnd cdt files produced by this function. In this heatmap, rows represent
genes and columns represent samples.

```{r, eval=TRUE, echo=FALSE, fig.show='hold', fig.width=8, fig.height=8, fig.align='center', warning=FALSE}
# retrieve file path for image
fpath <- system.file("extdata", "GSE2034_Breast.SD_Rank.ward.D2.Fixed_Probe_Num.Fixed_Clust_Num.jpg", package="multiClust")
knitr::include_graphics(path = fpath)
```

**Sample Dendrogram Example**

Below is an example of a sample dendrogram outputted by this function:

```{r, eval=TRUE, echo=FALSE, fig.show='hold', fig.width=8, fig.height=8, fig.align='center', warning=FALSE}
# Produce a sample dendrogram using the selected gene/probe expression object
# In the function, cluster_analysis the dendrogram is not displayed in
# the console. 

# Make the selected expression object numeric
colname <- colnames(ranked.exprs)
ranked.exprs <- t(apply(ranked.exprs, 1,as.numeric))
colnames(ranked.exprs) <- colname

# Normalization of the selected expression matrix before clustering
norm.sel.exp <- t(apply(ranked.exprs, 1, nor.min.max))

hc <- hclust(dist(x=t(norm.sel.exp), method="euclidean"), method="ward.D2")
dc <- as.dendrogram(hc)

# Portray the samples in each cluster as a different color
dc <- set(dc, "branches_k_color", value=1:3, k=3)

# Make a vector filled with blank spaces to replace sample names with
    # blank space
vec <- NULL
len <- length(labels(dc))
for (i in 1:len) {
  i <- ""
  vec <- c(vec, i)
}

# Remove sample labels from dendrogram
dc <- dendextend::set(dc, "labels", vec)

# Plot the sample dendrogram
plot(dc, main=paste("GSE2034 Breast", "Sample Dendrogram", sep=" "))

# Display orange lines on the plot to clearly separate each cluster
rect.dendrogram(dc, k=3, border='orange')

```

**Kmeans Clustering Example**

Below is an example of how to use the `cluster_analysis` function using the 
Kmeans clustering option:

```{r, eval=TRUE}

# Call the cluster_analysis function
 kmeans_analysis <- cluster_analysis(sel.exp=ranked.exprs,
    cluster_type="Kmeans",
    distance=NULL, linkage_type=NULL, 
    gene_distance=NULL, num_clusters=3,
    data_name="GSE2034 Breast", probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")
 
 # Display the first few rows and columns of the object
 head(kmeans_analysis)

```

**Function Outputs**

The output from this example would solely be an object "kmeans_analysis"
containing the vector of sample names and cluster number. There would be
no sample dendrogram file.

---

## 5. Obtaining the Average Expression for Each Gene/Probe in Each Cluster

The sixth function in this package `avg_probe_exp` is used to determine the
average expression of each gene/probe for the samples in a particular
cluster. 

**Function Arguments**

1. The first argument "sel.exp" is an object containing the numeric selected
gene/prone expression matrix. This object is an output of the `probe_ranking`
function.

2. The second argument "samp_cluster" is an object vector containing the
samples and the cluster number they belong to. This is an output of the
`cluster_analysis` function.

3. The third argument "data_name" is a string indicating the cancer type
and name of the dataset being analyzed.

4. The fourth argument "cluster_type" is a string indicating the type of
clustering method used in the `cluster_analysis` function. "Kmeans" or
"HClust" are the two options.

5. The fifth argument "distance" is a string describing the distance metric
used for HClust in the `cluster_analysis` function. Options include one of 
"euclidean", "maximum", manhattan", "canberra", "binary", or "minkowski".

6. The sixth argument "linkage_type" is a string describing the linkage
metric used in the HClust method in the `cluster_analysis` function.
Options include "ward.D2", "average", "complete", "median", "centroid",
"single", and "mcquitty".

7. The seventh argument "probe_rank" is a string indicating the feature
selection method used in the `probe_ranking` function. Options include
"CV_Rank", "CV_Guided", "SD_Rank", and "Poly".

8. The eighth argument "probe_num_selection" is a string indicating the way
in which probes were selected in the `number_probes` function. Examples
include "Fixed_Probe_Num", "Percent_Probe_Num", "Poly_Probe_Num", and
"Adaptive_Probe_Num".

9. The ninth argument "cluster_num_selection" is a string indicating how the 
number of clusters were determined in the `number_clusters` function.
Examples include "Fixed_Clust_Num" and "Gap_Statistic".

**Example**

Below is an example of how to use the `avg_probe_exp` function after
performing Kmeans clustering analysis with the `cluster_analysis` function:


```{r, eval=TRUE}

# Call the avg_probe_exp function
avg_matrix <- avg_probe_exp(sel.exp=ranked.exprs,
    samp_cluster=kmeans_analysis,
    data_name="GSE2034 Breast", cluster_type="Kmeans", distance=NULL,
    linkage_type=NULL, probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")

# Display the first few rows and columns of the matrix
head(avg_matrix)

```

**Function Outputs**

The outputs from this function are a text file containing the matrix of
average expression of each probe/gene in each of the different clusters.
In addition the object "avg_matrix" would also contain the average
expression matrix. 

---

## 6. Clinical Analysis of Selected Gene Probes and Samples 

After dividing the selected gene probes and samples into their respective
clusters, the `surv_analysis` function can be used to produce Kaplan-Meier
Survival Plots. This function uses a Cox Proportional Hazard Model to portray
the survival probabilities of the patients within each cluster over time. 

**Function Arguments**

1. The first argument "samp_cluster" is an object vector containing the 
samples and the cluster number they belong to. This object is an output 
of the `cluster_analysis` function.

2. The second argument "clinical" is a string indicating the name of the
text file containing patient clinical information. This file should be a 
matrix consisting of two columns. The first column contains the
patient survival time information in months. The second column indicates 
the occurrence of a censorship (0) or an event (1).

3. The third argument "survival_type" is a string specifying the type of 
survival event being analyzed. Examples include "Disease-free survival (DFS)",
"Overall Survival (OS)", "Relapse-free survival (RFS)", etc.

4. The fourth argument "data_name" is a string indicating the name to be used 
to label the Kaplan-Meier Survival Plot.

5. The fifth argument "cluster_type" is a string indicating the type of 
clustering method used in the `cluster_analysis` function. 
"Kmeans" or "HClust" are the two options.

6. The sixth argument "distance" is a string describing the distance 
metric uses for HClust in the `cluster_analysis` function. Options 
include one of "euclidean", "maximum", manhattan", "canberra", "binary",
or "minkowski".

7. The seventh argument "linkage_type" is a string describing the linkage 
metric used in the `cluster_analysis` function. Options include "ward.D2", 
"average", "complete", "median", "centroid", "single", and "mcquitty".

8. The eighth argument "probe_rank" is a string indicating the feature 
selection method used in the `probe_ranking` function. Options include
"CV_Rank", "CV_Guided", "SD_Rank", and "Poly".

The ninth argument "probe_num_selection" is a string indicating the way in
which probes were selected in the `number_probes` function. Options 
include "Fixed_Probe_Num", "Percent_Probe_Num", "Poly_Probe_Num",
and "Adaptive_Probee_Num".

The tenth argument "cluster_num_selection" is a string indicating how 
the number of clusters were determined in the `number_clusters` function. 
Options include "Fixed_Clust_Num" and "Gap_Statistic".


Below is an example of how to use the `surv_analysis` function:

**Example**

```{r, eval=TRUE, fig.show='hold'}
# Obtain clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")

# Call the avg_probe_exp function
surv <- surv_analysis(samp_cluster=kmeans_analysis, clinical=clin_file,
    survival_type="RFS", data_name="GSE2034 Breast", 
    cluster_type="Kmeans", distance=NULL,
    linkage_type=NULL, probe_rank="SD_Rank",
    probe_num_selection="Fixed_Probe_Num", 
    cluster_num_selection="Fixed_Clust_Num")

# Display the survival P value
surv

```

**Function Outputs**

This function outputs a pdf Kaplan-Meier Survival Plot of the patient
survival time in months vs. the survival probability. In this example,
the object "surv" will also contain the Cox Survival P value.

**Note**

The `surv_analysis` function also does not display the Kaplan-Meier plot
in the console, but rather outputs the plot as a pdf file. Below is an
example of what the plots would look like.

**Kaplan-Meier Survival Plot**

```{r, eval=TRUE, echo=FALSE, fig.show='hold', fig.width=8, fig.height=8, fig.align='center', warning=FALSE}

# Obtain clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")

# Produce a Kaplan-Meier plot using the sample cluster information
# from the cluster_analysis function

# Read in survival data text file
sample.anns <- read.delim2(file=clin_file, 
    header=TRUE, stringsAsFactors=FALSE)
time <- sample.anns[,1]
event <- sample.anns[,2]
time <- as.numeric(time)
event <- as.numeric(event)
event_type <- "RFS"
time_type <- 'Months'

# Determine max number of clusters in samp_cluster
samp_cluster <- kmeans_analysis
Number_Clusters <- max(samp_cluster)

# Produce Kaplan Meier survival plots
lev <- '1'
for(i in 2:Number_Clusters) {
    lev <- c(lev, paste('',i, sep=''))
}

groupfac <- factor(samp_cluster, levels=lev)
cox <- coxph(Surv(time, event==1) ~ groupfac)
csumm <- summary(cox)
cox.p.value <- c(csumm$logtest[3])
p <- survfit(Surv(time,event==1)~strata(samp_cluster))

plot (p,xlab= time_type ,ylab='Survival Probability',conf.int=FALSE, 
    xlim=c(0,100), col=1:Number_Clusters, 
    main=paste("GSE2034 Breast", "Kmeans", "SD_Rank", "RFS", sep =' '))

legend('bottomleft',legend=levels(strata(samp_cluster)),lty=1,
    col=1:Number_Clusters, text.col=1:Number_Clusters, title='clusters')

legend('topright', paste('Pvalue =', signif(csumm$logtest[3],digits=2),
    sep =''))

```


---

## 7. References

1. Davis, S. and Meltzer, P. S. GEOquery: a bridge between the Gene
Expression Omnibus (GEO) and BioConductor. Bioinformatics, 2007, 14,
1846-1847

2. Orchestrating high-throughput genomic analysis with Bioconductor. 
W. Huber, V.J. Carey, R. Gentleman, ..., M. Morgan Nature Methods,
2015:12, 115.

3. Benjamin Milo Bolstad. preprocessCore: A collection of pre-processing
functions. R package version 1.30.0.

4. Chris Fraley, Adrian E. Raftery, T. Brendan Murphy, and Luca Scrucca (2012)
mclust Version 4 for R: Normal Mixture Modeling for Model-Based Clustering,
Classification, and Density Estimation Technical Report No. 597,
Department of Statistics, University of Washington
  
5. Antoine Lucas and Laurent Gautier (2005). ctc: Cluster and
Tree Conversion.. R package version 1.42.0. http://antoinelucas.free.fr/ctc

6. Gregory R. Warnes, Ben Bolker, Lodewijk Bonebakker, Robert Gentleman, 
Wolfgang Huber Andy Liaw, Thomas Lumley, Martin Maechler, Arni Magnusson,
Steffen Moeller, Marc Schwartz and Bill Venables (2015).
gplots: Various R Programming Tools for Plotting Data. R package
version 2.17.0. http://CRAN.R-project.org/package=gplots

7. Therneau T (2015). _A Package for Survival Analysis in S. version 2.38,
<URL: http://CRAN.R-project.org/package=survival>.

8. Maechler, M., Rousseeuw, P., Struyf, A., Hubert, M., Hornik, K.(2015).
cluster: Cluster Analysis Basics and Extensions. R package version 2.0.3.

9. Tal Galili (2015). dendextend: Extending R's Dendrogram Functionality.
R package version 1.0.1. http://CRAN.R-project.org/package=dendextend

10. R Core Team (2015). R: A language and environment for statistical
computing. R Foundation for Statistical Computing, Vienna, Austria.
URL https://www.R-project.org/.

11. Saldanha, A. J. "Java Treeview--extensible Visualization of
Microarray Data."Bioinformatics 20.17 (2004): 3246-248.

12. Antoine Lucas (2014). amap: Another Multidimensional Analysis Package.
R package version 0.8-14. http://CRAN.R-project.org/package=amap

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/probe_ranking.R
\name{probe_ranking}
\alias{probe_ranking}
\title{Function to select for genes using one of the available gene
probe ranking options.}
\usage{
probe_ranking(input, probe_number, probe_num_selection = "Fixed_Probe_Num",
  data.exp, method = "SD_Rank")
}
\arguments{
\item{input}{String indicating the name of the text file containing
the gene expression matrix.}

\item{probe_number}{Positive integer indicating the number of gene probes
to be selected as determined by the number_probes function.}

\item{probe_num_selection}{String indicating the way in which number of
probes were selected for. Options include "Fixed_Probe_Num",
"Percent_Probe_Num", and "Adaptive_Probe_Num".}

\item{data.exp}{The object containing the original gene expression matrix.
This matrix is outputted by the input_file function.}

\item{method}{A string indicating the gene probe ranking method to use.
Possible options include "CV_Rank", "CV_Guided", "SD_Rank", and "Poly".
The default is set to "SD_Rank".}
}
\value{
An object containing the selected gene expression matrix for
a particular ranking method. In addition a text file containing the
selected gene expression data is produced.
}
\description{
Function to select for genes using one of the available gene
probe ranking options.
}
\note{
CV_Rank is a gene probe ranking method that selects for probes
with the highest coefficient of variation within the dataset.
CV_Guided is a method that also uses the coefficient of variation of the
dataset to select for gene probes. Every probe within the set is then
plotted on a mean and standard deviation graph (with SD being the y-axis).
A line is plotted starting from the origin with a slope of the coefficient
of variation. The mean and standard deviation cutoff moves along this line
until an equal or less then number of desired probes is above the cutoff.
SD_Rank is a gene probe ranking method that selects for probes with the
highest standard deviation within the dataset.
Poly is a ranking method that fits three second degree polynomial
functions of mean and standard deviation to the dataset to select
the most variable probes in the dataset.
}
\examples{
# Producing a selected gene expression matrix using one of the
   # probe ranking options
# Load in a test file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")
data <- input_file(data_file)
selected_probes <- probe_ranking(input=data_file, probe_number=300,
   probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
}
\author{
Peiyong Guan, Alec Fabbri, Nathan Lawlor
}
\seealso{
\code{\link{number_probes}}, \code{\link{input_file}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/input_file.R
\name{input_file}
\alias{input_file}
\title{Function to read-in the gene expression file and assign gene probe names
as the rownames.}
\usage{
input_file(input)
}
\arguments{
\item{input}{String indicating the name of the text file containing the
gene expression matrix to be read in. This matrix file should have the gene
probes in the first column of the matrix. The gene probes will be assigned
as the rownames of the matrix.}
}
\value{
Returns an object containing the gene expression matrix with the
gene probe names as the rownames.
}
\description{
Function to read-in the gene expression file and assign gene probe names
as the rownames.
}
\note{
This function works best when using gene expression datasets from
Gene Expression Omnibus.
}
\examples{
# Load in a test file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")
data <- input_file(input=data_file)
# View matrix with gene probes assigned as rownames
data[1:4, 1:4]
}
\author{
Nathan Lawlor
}
\seealso{
\code{\link[utils]{read.table}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/avg_probe_exp.R
\name{avg_probe_exp}
\alias{avg_probe_exp}
\title{Function to produce a matrix containing the average expression of each
gene probe within each sample cluster.}
\usage{
avg_probe_exp(sel.exp, samp_cluster, data_name, cluster_type = "HClust",
  distance = "euclidean", linkage_type = "ward.D2",
  probe_rank = "SD_Rank", probe_num_selection = "Fixed_Probe_Num",
  cluster_num_selection = "Fixed_Clust_Num")
}
\arguments{
\item{sel.exp}{Object containing the numeric selected gene
expression matrix. This object is an output of the probe_ranking function.}

\item{samp_cluster}{Object vector containing the samples and the cluster
number they belong to. This is an output of the cluster_analysis function.}

\item{data_name}{String indicating the cancer type and name of the
dataset being analyzed. This name will be used to label the sample
dendrograms and heatmap files.}

\item{cluster_type}{String indicating the type of clustering method
used in the cluster_analysis function. "Kmeans" or "HClust"
are the two options.}

\item{distance}{String describing the distance metric uses for HClust in
the cluster_analysis function. Options include one of "euclidean",
"maximum", manhattan", "canberra", "binary", or "minkowski".}

\item{linkage_type}{String describing the linkage metric used in the
cluster_analysis function. Options include "ward.D2", "average",
"complete", "median", "centroid", "single", and "mcquitty".}

\item{probe_rank}{String indicating the feature selection method used
in the probe_ranking function. Options include "CV_Rank", "CV_Guided",
"SD_Rank", and "Poly".}

\item{probe_num_selection}{String indicating the way in which probes
were selected in the number_probes function. Options include
"Fixed_Probe_Num", "Percent_Probe_Num", and "Adaptive_Probe_Num".}

\item{cluster_num_selection}{String indicating how the number of
clusters were determined in the number_clusters function. Options include
"Fixed_Clust_Num" and "Gap_Statistic".}
}
\value{
Returns an object matrix with the average mean expression for
each probe in each sample cluster. Also outputs the object to a text file.
}
\description{
Function to produce a matrix containing the average expression of each
gene probe within each sample cluster.
}
\examples{
# Produce matrix of average expression of each probe in each cluster
# Load in a data file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")
data <- input_file(input=data_file)
# Choose 300 genes to select for
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
   Percent=NULL, Adaptive=NULL)
# Choose the "CV_Rank" Method for gene ranking
sel.data <- probe_ranking(input=data_file, probe_number=300,
    probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
# Choose a fixed cluster number of 3
clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)
# Call function for Kmeans parameters
kmeans_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="Kmeans",
    distance=NULL, linkage_type=NULL, gene_distance=NULL,
    num_clusters=3, data_name="GSE2034 Breast",
    probe_rank="CV_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")
# Call function for average matrix expression calculation
avg_matrix <- avg_probe_exp(sel.exp=sel.data, samp_cluster=kmeans_analysis,
    data_name="GSE2034 Breast", cluster_type="Kmeans", distance=NULL,
    linkage_type=NULL, probe_rank="CV_Rank",
    probe_num_selection="Fixed", cluster_num_selection="Fixed_Clust_Num")
}
\author{
Nathan Lawlor, Alec Fabbri
}
\seealso{
\code{\link{number_clusters}}, \code{\link{number_probes}},
\code{\link{probe_ranking}}, \code{\link{cluster_analysis}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/number_clusters.R
\name{number_clusters}
\alias{number_clusters}
\title{Function to determine the number of clusters to be used
to cluster gene probes and samples.}
\usage{
number_clusters(data.exp, Fixed = 3, gap_statistic = NULL)
}
\arguments{
\item{data.exp}{The numeric original gene expression matrix to be used
for clustering of genes and samples. This object is an output
of the input_file function.}

\item{Fixed}{A positive integer used to represent the number of clusters
the samples and probes will be divided into. The default cluster number
is set to 3 clusters.}

\item{gap_statistic}{A logical indicating whether to use the
gap_statistic to determine the optimal number of clusters to
divide samples into.}
}
\value{
An object with the determined number of clusters to use.
}
\description{
Function to determine the number of clusters to be used
to cluster gene probes and samples.
}
\note{
The user should only choose either the fixed or gap_statistic
option, not both. When using the gap_statistic option, change the
argument to TRUE and "Fixed" to NULL.
}
\examples{

#Example 1: Using a fixed cluster number
# Load in a test file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
package="multiClust")
data <- input_file(data_file)
clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)

\dontrun{
# Example 2: Using the gap_statistic to determine the optimal cluster number
# Computation time is somewhat long
clust_num <- number_clusters(data.exp=data, Fixed=NULL, gap_statistic=TRUE)
 }
}
\author{
Nathan Lawlor, Alec Fabbri
}
\seealso{
\code{\link[cluster]{clusGap}}, \code{\link{probe_ranking}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/number_probes.R
\name{number_probes}
\alias{number_probes}
\title{Function to determine the number of gene probes to select for in the gene
feature selection process.}
\usage{
number_probes(input, data.exp, Fixed = 1000, Percent = NULL, Poly = NULL,
  Adaptive = NULL, cutoff = NULL)
}
\arguments{
\item{input}{String indicating the name of the file containing your
gene expression matrix.}

\item{data.exp}{The object containing your numeric gene expression matrix.
This matrix is an output of the input_file function previously introduced
in this package.}

\item{Fixed}{A positive integer specifying a desired number of gene probes
to select for. The default is set to 1000 gene probes.}

\item{Percent}{A positive integer between 0 and 100 indicating the
percentage of total gene probes to select for from the dataset.}

\item{Poly}{When TRUE, a mean and variance polynomial method is used to
determine the number of gene probes to select for. This method uses three
second order polynomials to select for the genes with the most variable
mean and standard deviations.}

\item{Adaptive}{When TRUE, Gaussian mixture modeling is used
to determine the number of gene probes to select.}

\item{cutoff}{Positive number between 0 and 1 specifying the false
discovery rate (FDR) cutoff to use with the Adaptive Gaussian mixture
modeling method. The default value is set to NULL. However, when Adaptive
is TRUE, cutoff should be a positive integer between 0 and 1. Common
values to use are 0.05 or 0.01.}
}
\value{
Returns an object with the  number of gene probes that will be
selected in the gene feature selection process. If the Adaptive option
is chosen, Gaussian mixture modeling files containing information about
the data's mean, variance, mixing proportion, and gaussian assignment
are also outputted.
}
\description{
Function to determine the number of gene probes to select for in the gene
feature selection process.
}
\note{
When using this function, the user should only use one
option (Fixed, Percent, Adaptive) at a time. When using one method, all
other options should be set to NULL.

This function is not needed to determine the number of gene probes
to select for in the Poly gene selection method.
The particular Poly method does not use a gene probe number input.
}
\examples{
# Example 1: Choosing a fixed gene probe number
# Load in a test file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")
data <- input_file(input=data_file)
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
    Percent=NULL, Poly=NULL, Adaptive=NULL, cutoff=NULL)

# Example 2: Choosing 50\% of the total selected gene probes in a dataset
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=NULL,
    Percent=50, Poly=NULL, Adaptive=NULL, cutoff=NULL)

# Example 3: Choosing the Poly method
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=NULL,
    Percent=NULL, Poly=TRUE, Adaptive=NULL, cutoff=NULL)
\dontrun{
# Example 4: Choosing the Adaptive Gaussian Mixture Modeling method
# Very long computation time, so example will not be run
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=NULL,
    Percent=NULL, Poly=NULL, Adaptive=TRUE, cutoff=0.01)
   }
}
\author{
Peiyong Guan, Nathan Lawlor
}
\seealso{
\code{\link{input_file}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nor.min.max.R
\name{nor.min.max}
\alias{nor.min.max}
\title{Function to normalize data to bring values into alignment. This function
uses feature scaling to normalize values in a dataset between 0 and 1.}
\usage{
nor.min.max(x)
}
\arguments{
\item{x}{An integer object of numeric value}
}
\value{
Returns a numeric value normalized between 0 and 1.
}
\description{
Function to normalize data to bring values into alignment. This function
uses feature scaling to normalize values in a dataset between 0 and 1.
}
\examples{

# Load sample dataset
data(iris)
# View sample matrix
iris[1:5, 1:5]
# Coerce sample matrix to numeric values
iris <- t(apply(iris[, 1:4], 1, as.numeric))
#Normalize values in the matrix using the function
data.min.max <- t(apply(iris, 1, nor.min.max))
}
\author{
Peiyong Guan
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster_analysis.R
\name{cluster_analysis}
\alias{cluster_analysis}
\title{Function to perform Kmeans or Hierarchical clustering analysis of the
selected gene probe expression data.}
\usage{
cluster_analysis(sel.exp, cluster_type = "HClust", seed = NULL,
  distance = "euclidean", linkage_type = "ward.D2",
  gene_distance = "correlation", num_clusters, data_name,
  probe_rank = "SD_Rank", probe_num_selection = "Fixed_Probe_Num",
  cluster_num_selection = "Fixed_Clust_Num")
}
\arguments{
\item{sel.exp}{Object containing the numeric selected gene expression
matrix. This object is an output of the probe_ranking function.}

\item{cluster_type}{String indicating the type of clustering method to use.
"Kmeans" or "HClust" are the two options. The default is set to "HClust".}

\item{seed}{A positive integer vector >1 indicating a random starting position
for the centers of the clusters to be used for the k-means clustering
algorithm. The default value is set to NULL and is not used when
Hierarchical clustering is chosen.}

\item{distance}{String describing the distance metric to use for
the dist function during hierarchical clustering. dist uses a default
distance metric of Euclidean distance. Options include one of "euclidean",
"maximum", manhattan", "canberra", "binary", or "minkowski". Kmeans
clustering does not use a distance metric. The default value is set
to "euclidean".}

\item{linkage_type}{String describing the linkage metric to be
used for HClust. The default is set to "ward.D2", however other options
include "average", "complete", "median", "centroid",
"single", and "mcquitty".}

\item{gene_distance}{String describing the distance measure to be used for
the Dist function when performing hierarchical clustering of genes.
Options include one of "euclidean", "maximum", "manhattan", "canberra",
"binary", "pearson", "abspearson", "correlation", "abscorrelation",
"spearman" or "kendall". The default of gene_distance is set
to "correlation". The deafult value is set to "correlation".
The argument can be set to NULL when Kmeans clustering is used.}

\item{num_clusters}{Positive integer to specify the number of clusters
samples will be divided into. This number is determined by the
number_clusters function.}

\item{data_name}{String indicating the cancer type and name of the
dataset being analyzed. This name will be used to label the sample
dendrograms and heatmap files.}

\item{probe_rank}{String indicating the feature selection method used
in the probe_ranking function. Options include "CV_Rank", "CV_Guided",
"SD_Rank", and "Poly".}

\item{probe_num_selection}{String indicating the way in which probes
were selected in the number_probes function. Options include
"Fixed_Probe_Num", "Percent_Probe_Num", and "Adaptive_Probe_Num".}

\item{cluster_num_selection}{String indicating how the number of clusters
were determined in the number_clusters function. Options include
"Fixed_Clust_Num" and "Gap_Statistic".}
}
\value{
Returns a vector containing the sample information and respective
cluster number. In addition, this function outpus sample cluster
dendrogams, average expression for each probe in each cluster, and
heatmap images and Java TreeView files for HClust dendrograms.
}
\description{
Function to perform Kmeans or Hierarchical clustering analysis of the
selected gene probe expression data.
}
\examples{

# Example 1: HClust Analysis
# Load in a data file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")
data <- input_file(input=data_file)
# Choose 300 genes to select for
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
    Percent=NULL, Adaptive=NULL)
# Choose the "CV_Rank" Method for gene ranking
sel.data <- probe_ranking(input=data_file, probe_number=300,
    probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
# Choose a fixed cluster number of 3
clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)

# Call function using HClust parameters
hclust_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="HClust",
    seed = NULL, distance="euclidean", linkage_type="ward.D2",
    gene_distance="correlation", num_clusters=3,
    data_name="GSE2034 Breast", probe_rank="CV_Rank",
    probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")

# Example 2: Kmeans Analysis
# Call function for Kmeans parameters
kmeans_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="Kmeans",
    seed = 1, distance=NULL, linkage_type=NULL, gene_distance=NULL,
    num_clusters=3, data_name="GSE2034 Breast",
    probe_rank="CV_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")
}
\author{
Nathan Lawlor, Alec Fabbri
}
\seealso{
\code{\link{probe_ranking}}, \code{\link{number_clusters}},
\code{\link{number_probes}}, \code{\link[stats]{hclust}},
\code{\link[stats]{kmeans}},
\code{\link[stats]{dist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/surv_analysis.R
\name{surv_analysis}
\alias{surv_analysis}
\title{Function to produce Kaplan-Meier Survival Plots of selected gene
expression data.}
\usage{
surv_analysis(samp_cluster, clinical, survival_type = "RFS", data_name,
  cluster_type = "HClust", distance = "euclidean",
  linkage_type = "ward.D2", probe_rank = "SD_Rank",
  probe_num_selection = "Fixed_Probe_Num",
  cluster_num_selection = "Fixed_Clust_Num")
}
\arguments{
\item{samp_cluster}{Object vector containing the samples and the cluster
number they belong to. This object is an output of the
cluster_analysis function.}

\item{clinical}{String indicating the name of the text file containing
patient clinical information. The file should be a data frame consisting
of two columns. The first column contains the patient survival time
information in months. The second column indicates occurrence of
a censorship (0) or an event (1).}

\item{survival_type}{String specifying the type of survival event being
analyzed. Examples include "Disease-free survival (DFS)",
"Overall Survival (OS)", "Relapse-free survival (RFS)", etc.}

\item{data_name}{String indicating the name to be used to label the plot.}

\item{cluster_type}{String indicating the type of clustering method
used in the cluster_analysis function. "Kmeans" or "HClust"
are the two options.}

\item{distance}{String describing the distance metric uses for HClust in
the cluster_analysis function. Options include one of "euclidean",
"maximum", manhattan", "canberra", "binary", or "minkowski".}

\item{linkage_type}{String describing the linkage metric use in the
cluster_analysis function. Options include "ward.D2", "average",
"complete", "median", "centroid", "single", and "mcquitty".}

\item{probe_rank}{String indicating the feature selection method used
in the probe_ranking function. Options include "CV_Rank",
"CV_Guided", "SD_Rank", and "Poly".}

\item{probe_num_selection}{String indicating the way in which probes
were selected in the number_probes function. Options include
"Fixed_Probe_Num", "Percent_Probe_Num", and "Adaptive_Probee_Num".}

\item{cluster_num_selection}{String indicating how the number of
clusters were determined in the number_clusters function. Options
include "Fixed_Clust_Num" and "Gap_Statistic".}
}
\value{
Produces a pdf image of a Kaplan-Meier Survival Plot with Cox
Survival P Value. Also returns an object containing the
cox survival P value.
}
\description{
Function to produce Kaplan-Meier Survival Plots of selected gene
expression data.
}
\examples{
# Load in a data file
data_file <- system.file("extdata", "GSE2034.normalized.expression.txt",
    package="multiClust")
data <- input_file(input=data_file)
# Choose 300 genes to select for
gene_num <- number_probes(input=data_file, data.exp=data, Fixed=300,
    Percent=NULL, Adaptive=NULL)
# Choose the "CV_Rank" Method for gene ranking
sel.data <- probe_ranking(input=data_file, probe_number=300,
    probe_num_selection="Fixed_Probe_Num", data.exp=data, method="CV_Rank")
# Choose a fixed cluster number of 3
clust_num <- number_clusters(data.exp=data, Fixed=3, gap_statistic=NULL)
# Call function for Kmeans parameters
kmeans_analysis <- cluster_analysis(sel.exp=sel.data, cluster_type="Kmeans",
    distance=NULL, linkage_type=NULL, gene_distance=NULL,
    num_clusters=3, data_name="GSE2034 Breast",
    probe_rank="CV_Rank", probe_num_selection="Fixed_Probe_Num",
    cluster_num_selection="Fixed_Clust_Num")
# Load the clinical outcome file
clin_file <- system.file("extdata", "GSE2034-RFS-clinical-outcome.txt",
    package="multiClust")
# Example of Calling surv_analysis function
surv <- surv_analysis(samp_cluster=kmeans_analysis, clinical=clin_file,
    survival_type="RFS", data_name="GSE2034 Breast", cluster_type="Kmeans",
     distance=NULL, linkage_type=NULL, probe_rank="CV_Rank",
     probe_num_selection="Fixed_Probe_Num",
     cluster_num_selection="Fixed_Cluster_Num")
}
\author{
Alec Fabbri, Nathan Lawlor
}
\seealso{
\code{\link{number_clusters}}, \code{\link{number_probes}},
\code{\link{probe_ranking}}, \code{\link{cluster_analysis}},
\code{\link[survival]{coxph}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WriteMatrixToFile.R
\name{WriteMatrixToFile}
\alias{WriteMatrixToFile}
\title{Function to write a data matrix to a text file.}
\usage{
WriteMatrixToFile(tmpMatrix, tmpFileName, blnRowNames, blnColNames)
}
\arguments{
\item{tmpMatrix}{The object matrix containing data.}

\item{tmpFileName}{The string name of the text file to write the matrix to.}

\item{blnRowNames}{Logical value indicating if row names of the matrix
should be written along with the matrix.}

\item{blnColNames}{Logical value indicating if the column names of the
matrix should be written with the matrix.}
}
\value{
Text file containing the data matrix.
}
\description{
Function to write a data matrix to a text file.
}
\examples{

#Load sample dataset
data(iris)
# View sample matrix
iris[1:4, 1:4]
# Write sample matrix to text file
WriteMatrixToFile(tmpMatrix=iris, tmpFileName="iris.sample.matrix.txt",
blnRowNames=TRUE, blnColNames=TRUE)

}
\author{
Peiyong Guan
}
\seealso{
\code{\link[utils]{write.table}}
}
